/****************************************************************
 *              TLCS-900 C Compiler Header File                 *
 *--------------------------------------------------------------*
 *      [For]           {TMP91FY22F}                            *
 *  [File name]     {IO900L1.C}                                 *
 *      [Subject]       {Special Function Registers}            *
 ****************************************************************/
unsigned char   __io(0x00)      IOP0;           // Port0
unsigned char   __io(0x01)      IOP1;           // Port1
unsigned char   __io(0x02)      P0CR;           // Port0 control
unsigned char   __io(0x04)      P1CR;           // Port1 control
unsigned char   __io(0x05)      P1FC;           // Port1 function
unsigned char   __io(0x06)      IOP2;           // Port2
unsigned char   __io(0x07)      IOP3;           // Port3
unsigned char   __io(0x08)      P2CR;           // Port2 control
unsigned char   __io(0x09)      P2FC;           // Port2 function
unsigned char   __io(0x0a)      P3CR;           // Port3 control
unsigned char   __io(0x0b)      P3FC;           // Port3 function
unsigned char   __io(0x0c)      IOP4;           // Port4
unsigned char   __io(0x0d)      IOP5;           // Port5
unsigned char   __io(0x0e)      P4CR;           // Port4 control
unsigned char   __io(0x0f)      P4FC;           // Port4 function

unsigned char   __io(0x12)      IOP6;           // Port6
unsigned char   __io(0x13)      IOP7;           // Port7
unsigned char   __io(0x14)      P6CR;           // Port6 control
unsigned char   __io(0x15)      P6FC;           // Port6 function
unsigned char   __io(0x16)      P7CR;           // Port7 control
unsigned char   __io(0x17)      P7FC;           // Port7 function
unsigned char   __io(0x18)      IOP8;           // Port8
unsigned char   __io(0x19)      IOP9;           // Port9
unsigned char   __io(0x1a)      P8CR;           // Port8 control
unsigned char   __io(0x1b)      P8FC;           // Port8 function
unsigned char   __io(0x1c)      P9CR;           // Port9 control
unsigned char   __io(0x1d)      P9FC;           // Port9 function
unsigned char   __io(0x1e)      IOPA;           // PortA
unsigned char   __io(0x20)      PACR;           // PortA control
unsigned char   __io(0x21)      PAFC;           // PortA function
unsigned char   __io(0x2f)      ODE;            // Serial out control

unsigned char   __io(0x80)      DMA0V;          // DMA0 Start vector register
unsigned char   __io(0x81)      DMA1V;          // DMA1 Start vector register
unsigned char   __io(0x82)      DMA2V;          // DMA2 Start vector register
unsigned char   __io(0x83)      DMA3V;          // DMA3 Start vector register
unsigned char   __io(0x88)      INTCLR;         // Interrupt clear control register
unsigned char   __io(0x89)      DMAR;           // DMA Software request register
unsigned char   __io(0x8a)      DMAB;           // DMA Burst register
unsigned char   __io(0x8c)      IIMC;           // Interrupt input mode control register

unsigned char   __io(0x90)      INTE0AD;        // Interrupt priority setting register
unsigned char   __io(0x91)      INTE12;         // Interrupt priority setting register
unsigned char   __io(0x92)      INTE34;         // Interrupt priority setting register
unsigned char   __io(0x93)      INTE56;         // Interrupt priority setting register
unsigned char   __io(0x94)      INTE78;         // Interrupt priority setting register
unsigned char   __io(0x95)      INTETA01;       // Interrupt priority setting register
unsigned char   __io(0x96)      INTETA23;       // Interrupt priority setting register
unsigned char   __io(0x97)      INTETA45;       // Interrupt priority setting register
unsigned char   __io(0x98)      INTETA67;       // Interrupt priority setting register
unsigned char   __io(0x99)      INTETB0;        // Interrupt priority setting register
unsigned char   __io(0x9a)      INTETB1;        // Interrupt priority setting register
unsigned char   __io(0x9b)      INTETB01V;      // Interrupt priority setting register
unsigned char   __io(0x9c)      INTES0;         // Interrupt priority setting register
unsigned char   __io(0x9d)      INTES1;         // Interrupt priority setting register
unsigned char   __io(0x9e)      INTES2RTC;      // Interrupt priority setting register
unsigned char   __io(0xa0)      INTETC01;       // Interrupt priority setting register
unsigned char   __io(0xa1)      INTETC23;       // Interrupt priority setting register

unsigned char   __io(0xc0)      B0CS;           // Chip select/Wait control register(CS0)
unsigned char   __io(0xc1)      B1CS;           // Chip select/Wait control register(CS1)
unsigned char   __io(0xc2)      B2CS;           // Chip select/Wait control register(CS2)
unsigned char   __io(0xc3)      B3CS;           // Chip select/Wait control register(CS3)
unsigned char   __io(0xc7)      BEXCS;          // Chip select/Wait control register(others)
unsigned char   __io(0xc8)      MSAR0;          // Memory start address register(CS0)
unsigned char   __io(0xc9)      MAMR0;          // Memory address mask register (CS0)
unsigned char   __io(0xca)      MSAR1;          // Memory start address register(CS1)
unsigned char   __io(0xcb)      MAMR1;          // Memory address mask register (CS1)
unsigned char   __io(0xcc)      MSAR2;          // Memory start address register(CS2)
unsigned char   __io(0xcd)      MAMR2;          // Memory address mask register (CS2)
unsigned char   __io(0xce)      MSAR3;          // Memory start address register(CS3)
unsigned char   __io(0xcf)      MAMR3;          // Memory address mask register (CS3)

unsigned char   __io(0xe0)      SYSCR0;         // SFR for system clock
unsigned char   __io(0xe1)      SYSCR1;         // SFR for system clock
unsigned char   __io(0xe2)      SYSCR2;         // SFR for system clock
unsigned char   __io(0xe3)      EMCCR0;         // SFR for noise-reducing
unsigned char   __io(0xe4)      EMCCR1;         // SFR for noise-reducing
unsigned char   __io(0xe8)      DFMCR0;         // SFR for DFM 0
unsigned char   __io(0xe9)      DFMCR1;         // SFR for DFM 1

unsigned char   __io(0x100)     TA01RUN;        // TMRA01 RUN register
unsigned char   __io(0x102)     TA0REG;         // Timer register0
unsigned char   __io(0x103)     TA1REG;         // Timer register1
unsigned char   __io(0x104)     TA01MOD;        // TMRA01 Mode register
unsigned char   __io(0x105)     TA1FFCR;        // TMRA1 Flip-flop control register
unsigned char   __io(0x108)     TA23RUN;        // TMRA23 RUN register
unsigned char   __io(0x10a)     TA2REG;         // Timer register2
unsigned char   __io(0x10b)     TA3REG;         // Timer register3
unsigned char   __io(0x10c)     TA23MOD;        // TMRA23 Mode register
unsigned char   __io(0x10d)     TA3FFCR;        // TMRA3 Flip-flop control register

unsigned char   __io(0x110)     TA45RUN;        // TMRA45 RUN register
unsigned char   __io(0x112)     TA4REG;         // Timer register4
unsigned char   __io(0x113)     TA5REG;         // Timer register5
unsigned char   __io(0x114)     TA45MOD;        // TMRA45 Mode register
unsigned char   __io(0x115)     TA5FFCR;        // TMRA5 Flip-flop control register
unsigned char   __io(0x118)     TA67RUN;        // TMRA67 RUN register
unsigned char   __io(0x11a)     TA6REG;         // Timer register6
unsigned char   __io(0x11b)     TA7REG;         // Timer register7
unsigned char   __io(0x11c)     TA67MOD;        // TMRA67 Mode register
unsigned char   __io(0x11d)     TA7FFCR;        // TMRA7 Flip-flop control register

unsigned char   __io(0x180)     TB0RUN;         // TMRB0 RUN register
unsigned char   __io(0x182)     TB0MOD;         // TMRB0 Mode register
unsigned char   __io(0x183)     TB0FFCR;        // TMRB0 Flip-flop control register
unsigned char   __io(0x188)     TB0RG0L;        // TMRB0 Timer register0[low]
unsigned char   __io(0x189)     TB0RG0H;        // TMRB0 Timer register0[high]
// unsigned int    __io(0x18a)     TB0RG1;         // TMRB0 Timer register1
unsigned char   __io(0x18a)     TB0RG1L;        // TMRB0 Timer register1[low]
unsigned char   __io(0x18b)     TB0RG1H;        // TMRB0 Timer register1[high]
// unsigned int    __io(0x18c)     TB0CP0;         // TMRB0 Capture register0
unsigned char   __io(0x18c)     TB0CP0L;        // TMRB0 Capture register0[low]
unsigned char   __io(0x18d)     TB0CP0H;        // TMRB0 Capture register0[high]
// unsigned int    __io(0x18e)     TB0CP1;         // TMRB0 Capture register1
unsigned char   __io(0x18e)     TB0CP1L;        // TMRB0 Capture register1[low]
unsigned char   __io(0x18f)     TB0CP1H;        // TMRB0 Capture register1[high]
                                 
unsigned char   __io(0x190)     TB1RUN;         // TMRB1 RUN register
unsigned char   __io(0x192)     TB1MOD;         // TMRB1 Mode register
unsigned char   __io(0x193)     TB1FFCR;        // TMRB1 Flip-flop control register
unsigned char   __io(0x198)     TB1RG0L;        // TMRB1 Timer register0[low]
unsigned char   __io(0x199)     TB1RG0H;        // TMRB1 Timer register0[high]
// unsigned int    __io(0x19a)     TB1RG1;         // TMRB1 Timer register1
unsigned char   __io(0x19a)     TB1RG1L;        // TMRB1 Timer register1[low]
unsigned char   __io(0x19b)     TB1RG1H;        // TMRB1 Timer register1[high]
// unsigned int    __io(0x19c)     TB1CP0;         // TMRB1 Capture register0
unsigned char   __io(0x19c)     TB1CP0L;        // TMRB1 Capture register0[low]
unsigned char   __io(0x19d)     TB1CP0H;        // TMRB1 Capture register0[high]
// unsigned int    __io(0x19e)     TB1CP1;         // TMRB1 Capture register1
unsigned char   __io(0x19e)     TB1CP1L;        // TMRB1 Capture register1[low]
unsigned char   __io(0x19f)     TB1CP1H;        // TMRB1 Capture register1[high]
                               
unsigned char   __io(0x200)     SC0BUF;         // Serial transmission/Receiving buffer register(SIO0)
unsigned char   __io(0x201)     SC0CR;          // Serial control register(SIO0)
unsigned char   __io(0x202)     SC0MOD0;        // Serial mode control register0(SIO0)
unsigned char   __io(0x203)     BR0CR;          // Baud rate generator control register(SIO0)
unsigned char   __io(0x204)     BR0ADD;         // Baud rate generator control register(SIO0)
unsigned char   __io(0x205)     SC0MOD1;        // Serial mode control register1(SIO0)
unsigned char   __io(0x207)     SIRCR;          // IrDA control register
unsigned char   __io(0x208)     SC1BUF;         // Serial transmission/Receiving buffer register(SIO1)
unsigned char   __io(0x209)     SC1CR;          // Serial control register(SIO1)
unsigned char   __io(0x20a)     SC1MOD0;        // Serial mode control register0(SIO1)
unsigned char   __io(0x20b)     BR1CR;          // Baud rate generator control register(SIO1)
unsigned char   __io(0x20c)     BR1ADD;         // Baud rate generator control register(SIO1)
unsigned char   __io(0x20d)     SC1MOD1;        // Serial mode control register1(SIO1)

unsigned char   __io(0x240)     SBI0CR1;        // Serial bus interface control register1
unsigned char   __io(0x241)     SBI0DBR;        // Serial bus interface data buffer register
unsigned char   __io(0x242)     I2C0AR;         // I2C Bus address register
unsigned char   __io(0x243)     SBI0CR2;        // Serial bus interface control register2
// unsigned char   __io(0x243)     SBI0SR;         // Serial bus interface status register
unsigned char   __io(0x244)     SBI0BR0;        // Serial bus interface baud rate register0
unsigned char   __io(0x245)     SBI0BR1;        // Serial bus interface baud rate register1

unsigned int    __io(0x2a0)     ADREG04;        // A/D Conversion data lower register0/4
// unsigned char   __io(0x2a0)     ADREG04L;       // A/D Conversion data lower register0/4
// unsigned char   __io(0x2a1)     ADREG04H;       // A/D Conversion data upper register0/4
unsigned int    __io(0x2a2)     ADREG15;        // A/D Conversion data lower register1/5
// unsigned char   __io(0x2a2)     ADREG15L;       // A/D Conversion data lower register1/5
// unsigned char   __io(0x2a3)     ADREG15H;       // A/D Conversion data upper register1/5
unsigned int    __io(0x2a4)     ADREG26;        // A/D Conversion data lower register2/6
// unsigned char   __io(0x2a4)     ADREG26L;       // A/D Conversion data lower register2/6
// unsigned char   __io(0x2a5)     ADREG26H;       // A/D Conversion data upper register2/6
unsigned int    __io(0x2a6)     ADREG37;        // A/D Conversion data lower register3/7
// unsigned char   __io(0x2a6)     ADREG37L;       // A/D Conversion data lower register3/7
// unsigned char   __io(0x2a7)     ADREG37H;       // A/D Conversion data upper register3/7
unsigned char   __io(0x2b0)     ADMOD0;         // A/D Mode control register0
unsigned char   __io(0x2b1)     ADMOD1;         // A/D Mode control register1
unsigned char   __io(0x300)     WDMOD;          // Watchdog timer mode register
unsigned char   __io(0x301)     WDCR;           // Watchdog timer control register
unsigned char   __io(0x310)     RTCCR;          // Timer for real time clock control register
