/****************************************************************
 *              TLCS-900 C Compiler Header File                 *
 *--------------------------------------------------------------*
 *      [For]           {TMP91FY22}                             *
 *      [File name]     {IO900L2.H}                             *
 *      [Subject]       {Special Function Registers}            *
 ****************************************************************/
extern unsigned char   __io(0x00)     IOP0;      // 0x00: Port0
extern unsigned char   __io(0x01)     IOP1;      // 0x01: Port1
extern unsigned char   __io(0x02)     P0CR;      // 0x02: Port0 control
extern unsigned char   __io(0x04)     P1CR;      // 0x04: Port1 control
extern unsigned char   __io(0x05)     P1FC;      // 0x05: Port1 function
extern unsigned char   __io(0x06)     IOP2;      // 0x06: Port2
extern unsigned char   __io(0x07)     IOP3;      // 0x07: Port3
extern unsigned char   __io(0x08)     P2CR;      // 0x08: Port2 control
extern unsigned char   __io(0x09)     P2FC;      // 0x09: Port2 function
extern unsigned char   __io(0x0a)     P3CR;      // 0x0a: Port3 control
extern unsigned char   __io(0x0b)     P3FC;      // 0x0b: Port3 function
extern unsigned char   __io(0x0c)     IOP4;      // 0x0c: Port4
extern unsigned char   __io(0x0d)     IOP5;      // 0x0d: Port5
extern unsigned char   __io(0x0e)     P4CR;      // 0x0e: Port4 control
extern unsigned char   __io(0x0f)     P4FC;      // 0x0f: Port4 function
extern unsigned char   __io(0x12)     IOP6;      // 0x12: Port6
extern unsigned char   __io(0x13)     IOP7;      // 0x13: Port7
extern unsigned char   __io(0x14)     P6CR;      // 0x14: Port6 control
extern unsigned char   __io(0x15)     P6FC;      // 0x15: Port6 function
extern unsigned char   __io(0x16)     P7CR;      // 0x16: Port7 control
extern unsigned char   __io(0x17)     P7FC;      // 0x17: Port7 function
extern unsigned char   __io(0x18)     IOP8;      // 0x18: Port8
extern unsigned char   __io(0x19)     IOP9;      // 0x19: Port9
extern unsigned char   __io(0x1a)     P8CR;      // 0x1a: Port8 control
extern unsigned char   __io(0x1b)     P8FC;      // 0x1b: Port8 function
extern unsigned char   __io(0x1c)     P9CR;      // 0x1c: Port9 control
extern unsigned char   __io(0x1d)     P9FC;      // 0x1d: Port9 function
extern unsigned char   __io(0x1e)     IOPA;      // 0x1e: PortA

extern unsigned char   __io(0x20)     PACR;      // 0x20: PortA control
extern unsigned char   __io(0x21)     PAFC;      // 0x21: PortA function
extern unsigned char   __io(0x2f)     ODE;       // 0x2f: Serial out control
extern unsigned char   __io(0x80)     DMA0V;     // 0x80: DMA0 Start vector register
extern unsigned char   __io(0x81)     DMA1V;     // 0x81: DMA1 Start vector register
extern unsigned char   __io(0x82)     DMA2V;     // 0x82: DMA2 Start vector register
extern unsigned char   __io(0x83)     DMA3V;     // 0x83: DMA3 Start vector register
extern unsigned char   __io(0x88)     INTCLR;    // 0x88: Interrupt clear control register
extern unsigned char   __io(0x89)     DMAR;      // 0x89: DMA Software request register
extern unsigned char   __io(0x8a)     DMAB;      // 0x8a: DMA Burst register
extern unsigned char   __io(0x8c)     IIMC;      // 0x8c: Interrupt input mode control register
extern unsigned char   __io(0x90)     INTE0AD;   // 0x90: Interrupt priority setting register
extern unsigned char   __io(0x91)     INTE12;    // 0x91: Interrupt priority setting register
extern unsigned char   __io(0x92)     INTE34;    // 0x92: Interrupt priority setting register
extern unsigned char   __io(0x93)     INTE56;    // 0x93: Interrupt priority setting register
extern unsigned char   __io(0x94)     INTE78;    // 0x94: Interrupt priority setting register
extern unsigned char   __io(0x95)     INTETA01;  // 0x95: Interrupt priority setting register
extern unsigned char   __io(0x96)     INTETA23;  // 0x96: Interrupt priority setting register
extern unsigned char   __io(0x97)     INTETA45;  // 0x97: Interrupt priority setting register
extern unsigned char   __io(0x98)     INTETA67;  // 0x98: Interrupt priority setting register
extern unsigned char   __io(0x99)     INTETB0;   // 0x99: Interrupt priority setting register
extern unsigned char   __io(0x9a)     INTETB1;   // 0x9a: Interrupt priority setting register
extern unsigned char   __io(0x9b)     INTETB01V; // 0x9b: Interrupt priority setting register
extern unsigned char   __io(0x9c)     INTES0;    // 0x9c: Interrupt priority setting register
extern unsigned char   __io(0x9d)     INTES1;    // 0x9d: Interrupt priority setting register
extern unsigned char   __io(0x9e)     INTES2RTC; // 0x9e: Interrupt priority setting register

extern unsigned char   __io(0xa0)     INTETC01;  // 0xa0: Interrupt priority setting register
extern unsigned char   __io(0xa1)     INTETC23;  // 0xa1: Interrupt priority setting register
extern unsigned char   __io(0xc0)     B0CS;      // 0xc0: Chip select/Wait control register(CS0)
extern unsigned char   __io(0xc1)     B1CS;      // 0xc1: Chip select/Wait control register(CS1)
extern unsigned char   __io(0xc2)     B2CS;      // 0xc2: Chip select/Wait control register(CS2)
extern unsigned char   __io(0xc3)     B3CS;      // 0xc3: Chip select/Wait control register(CS3)
extern unsigned char   __io(0xc7)     BEXCS;     // 0xc7: Chip select/Wait control register(others)
extern unsigned char   __io(0xc8)     MSAR0;     // 0xc8: Memory start address register(CS0)
extern unsigned char   __io(0xc9)     MAMR0;     // 0xc9: Memory address mask register (CS0)
extern unsigned char   __io(0xca)     MSAR1;     // 0xca: Memory start address register(CS1)
extern unsigned char   __io(0xcb)     MAMR1;     // 0xcb: Memory address mask register (CS1)
extern unsigned char   __io(0xcc)     MSAR2;     // 0xcc: Memory start address register(CS2)
extern unsigned char   __io(0xcd)     MAMR2;     // 0xcd: Memory address mask register (CS2)
extern unsigned char   __io(0xce)     MSAR3;     // 0xce: Memory start address register(CS3)
extern unsigned char   __io(0xcf)     MAMR3;     // 0xcf: Memory address mask register (CS3)
extern unsigned char   __io(0xe0)     SYSCR0;    // 0xe0: SFR for system clock
extern unsigned char   __io(0xe1)     SYSCR1;    // 0xe1: SFR for system clock
extern unsigned char   __io(0xe2)     SYSCR2;    // 0xe2: SFR for system clock
extern unsigned char   __io(0xe3)     EMCCR0;    // 0xe3: SFR for noise-reducing
extern unsigned char   __io(0xe4)     EMCCR1;    // 0xe4: SFR for noise-reducing
extern unsigned char   __io(0xe8)     DFMCR0;    // 0xe8: SFR for DFM 0
extern unsigned char   __io(0xe9)     DFMCR1;    // 0xe9: SFR for DFM 1

extern unsigned char   __io(0x100)    TA01RUN;   // 0x100: TMRA01 RUN register
extern unsigned char   __io(0x102)    TA0REG;    // 0x102: Timer register0
extern unsigned char   __io(0x103)    TA1REG;    // 0x103: Timer register1
extern unsigned char   __io(0x104)    TA01MOD;   // 0x104: TMRA01 Mode register
extern unsigned char   __io(0x105)    TA1FFCR;   // 0x105: TMRA1 Flip-flop control register
extern unsigned char   __io(0x108)    TA23RUN;   // 0x108: TMRA23 RUN register
extern unsigned char   __io(0x10a)    TA2REG;    // 0x10a: Timer register2
extern unsigned char   __io(0x10b)    TA3REG;    // 0x10b: Timer register3
extern unsigned char   __io(0x10c)    TA23MOD;   // 0x10c: TMRA23 Mode register
extern unsigned char   __io(0x10d)    TA3FFCR;   // 0x10d: TMRA3 Flip-flop control register
extern unsigned char   __io(0x110)    TA45RUN;   // 0x110: TMRA45 RUN register
extern unsigned char   __io(0x112)    TA4REG;    // 0x112: Timer register4
extern unsigned char   __io(0x113)    TA5REG;    // 0x113: Timer register5
extern unsigned char   __io(0x114)    TA45MOD;   // 0x114: TMRA45 Mode register
extern unsigned char   __io(0x115)    TA5FFCR;   // 0x115: TMRA5 Flip-flop control register
extern unsigned char   __io(0x118)    TA67RUN;   // 0x118: TMRA67 RUN register
extern unsigned char   __io(0x11a)    TA6REG;    // 0x11a: Timer register6
extern unsigned char   __io(0x11b)    TA7REG;    // 0x11b: Timer register7
extern unsigned char   __io(0x11c)    TA67MOD;   // 0x11c: TMRA67 Mode register
extern unsigned char   __io(0x11d)    TA7FFCR;   // 0x11d: TMRA7 Flip-flop control register

extern unsigned char   __io(0x180)    TB0RUN;    // 0x180: TMRB0 RUN register
extern unsigned char   __io(0x182)    TB0MOD;    // 0x182: TMRB0 Mode register
extern unsigned char   __io(0x183)    TB0FFCR;   // 0x183: TMRB0 Flip-flop control register
extern unsigned int    __io(0x188)    TB0RG0;    // 0x188: TMRB0 Timer register0
extern unsigned char   __io(0x188)    TB0RG0L;   // 0x188: TMRB0 Timer register0[low]
extern unsigned char   __io(0x189)    TB0RG0H;   // 0x189: TMRB0 Timer register0[high]
extern unsigned int    __io(0x18a)    TB0RG1;    // 0x18a: TMRB0 Timer register1
extern unsigned char   __io(0x18a)    TB0RG1L;   // 0x18a: TMRB0 Timer register1[low]
extern unsigned char   __io(0x18b)    TB0RG1H;   // 0x18b: TMRB0 Timer register1[high]
extern unsigned int    __io(0x18c)    TB0CP0;    // 0x18c: TMRB0 Capture register0
extern unsigned char   __io(0x18c)    TB0CP0L;   // 0x18c: TMRB0 Capture register0[low]
extern unsigned char   __io(0x18d)    TB0CP0H;   // 0x18d: TMRB0 Capture register0[high]
extern unsigned int    __io(0x18e)    TB0CP1;    // 0x18e: TMRB0 Capture register1
extern unsigned char   __io(0x18e)    TB0CP1L;   // 0x18e: TMRB0 Capture register1[low]
extern unsigned char   __io(0x18f)    TB0CP1H;   // 0x18f: TMRB0 Capture register1[high]

extern unsigned char   __io(0x190)    TB1RUN;    // 0x190: TMRB1 RUN register
extern unsigned char   __io(0x192)    TB1MOD;    // 0x192: TMRB1 Mode register
extern unsigned char   __io(0x193)    TB1FFCR;   // 0x193: TMRB1 Flip-flop control register
extern unsigned int    __io(0x198)    TB1RG0;    // 0x198: TMRB1 Timer register0
extern unsigned char   __io(0x198)    TB1RG0L;   // 0x198: TMRB1 Timer register0[low]
extern unsigned char   __io(0x199)    TB1RG0H;   // 0x199: TMRB1 Timer register0[high]
extern unsigned int    __io(0x19a)    TB1RG1;    // 0x19a: TMRB1 Timer register1
extern unsigned char   __io(0x19a)    TB1RG1L;   // 0x19a: TMRB1 Timer register1[low]
extern unsigned char   __io(0x19b)    TB1RG1H;   // 0x19b: TMRB1 Timer register1[high]
extern unsigned int    __io(0x19c)    TB1CP0;    // 0x19c: TMRB1 Capture register0
extern unsigned char   __io(0x19c)    TB1CP0L;   // 0x19c: TMRB1 Capture register0[low]
extern unsigned char   __io(0x19d)    TB1CP0H;   // 0x19d: TMRB1 Capture register0[high]
extern unsigned int    __io(0x19e)    TB1CP1;    // 0x19e: TMRB1 Capture register1
extern unsigned char   __io(0x19e)    TB1CP1L;   // 0x19e: TMRB1 Capture register1[low]
extern unsigned char   __io(0x19f)    TB1CP1H;   // 0x19f: TMRB1 Capture register1[high]

extern unsigned char   __io(0x200)    SC0BUF;    // 0x200: Serial transmission/Receiving buffer register(SIO0)
extern unsigned char   __io(0x201)    SC0CR;     // 0x201: Serial control register(SIO0)
extern unsigned char   __io(0x202)    SC0MOD0;   // 0x202: Serial mode control register0(SIO0)
extern unsigned char   __io(0x203)    BR0CR;     // 0x203: Baud rate generator control register(SIO0)
extern unsigned char   __io(0x204)    BR0ADD;    // 0x204: Baud rate generator control register(SIO0)
extern unsigned char   __io(0x205)    SC0MOD1;   // 0x205: Serial mode control register1(SIO0)
extern unsigned char   __io(0x207)    SIRCR;     // 0x207: IrDA control register
extern unsigned char   __io(0x208)    SC1BUF;    // 0x208: Serial transmission/Receiving buffer register(SIO1)
extern unsigned char   __io(0x209)    SC1CR;     // 0x209: Serial control register(SIO1)
extern unsigned char   __io(0x20a)    SC1MOD0;   // 0x20a: Serial mode control register0(SIO1)
extern unsigned char   __io(0x20b)    BR1CR;     // 0x20b: Baud rate generator control register(SIO1)
extern unsigned char   __io(0x20c)    BR1ADD;    // 0x20c: Baud rate generator control register(SIO1)
extern unsigned char   __io(0x20d)    SC1MOD1;   // 0x20d: Serial mode control register1(SIO1)
extern unsigned char   __io(0x240)    SBI0CR1;   // 0x240: Serial bus interface control register1
extern unsigned char   __io(0x241)    SBI0DBR;   // 0x241: Serial bus interface data buffer register
extern unsigned char   __io(0x242)    I2C0AR;    // 0x242: I2C Bus address register
extern unsigned char   __io(0x243)    SBI0CR2;   // 0x243: Serial bus interface control register2
extern unsigned char   __io(0x243)    SBI0SR;    // 0x243: Serial bus interface status register
extern unsigned char   __io(0x244)    SBI0BR0;   // 0x244: Serial bus interface baud rate register0
extern unsigned char   __io(0x245)    SBI0BR1;   // 0x245: Serial bus interface baud rate register1

extern unsigned int    __io(0x2a0)    ADREG04;   // 0x2a0: A/D Conversion data lower register0/4
extern unsigned char   __io(0x2a0)    ADREG04L;  // 0x2a0: A/D Conversion data lower register0/4
extern unsigned char   __io(0x2a1)    ADREG04H;  // 0x2a1: A/D Conversion data upper register0/4
extern unsigned int    __io(0x2a2)    ADREG15;   // 0x2a2: A/D Conversion data lower register1/5
extern unsigned char   __io(0x2a2)    ADREG15L;  // 0x2a2: A/D Conversion data lower register1/5
extern unsigned char   __io(0x2a3)    ADREG15H;  // 0x2a3: A/D Conversion data upper register1/5
extern unsigned int    __io(0x2a4)    ADREG26;   // 0x2a4: A/D Conversion data lower register2/6
extern unsigned char   __io(0x2a4)    ADREG26L;  // 0x2a4: A/D Conversion data lower register2/6
extern unsigned char   __io(0x2a5)    ADREG26H;  // 0x2a5: A/D Conversion data upper register2/6
extern unsigned int    __io(0x2a6)    ADREG37;   // 0x2a6: A/D Conversion data lower register3/7
extern unsigned char   __io(0x2a6)    ADREG37L;  // 0x2a6: A/D Conversion data lower register3/7
extern unsigned char   __io(0x2a7)    ADREG37H;  // 0x2a7: A/D Conversion data upper register3/7
extern unsigned char   __io(0x2b0)    ADMOD0;    // 0x2b0: A/D Mode control register0
extern unsigned char   __io(0x2b1)    ADMOD1;    // 0x2b1: A/D Mode control register1
extern unsigned char   __io(0x300)    WDMOD;     // 0x300: Watchdog timer mode register
extern unsigned char   __io(0x301)    WDCR;      // 0x301: Watchdog timer control register
extern unsigned char   __io(0x310)    RTCCR;     // 0x310: Timer for real time clock control register
