/*===================================================================*/
/*              Program setting for TLCS-900  [ SAMPLE ]             */
/*                      (On-chip Hardware setting)                   */
/*                        [TMP96CM40/TMP96PM40]                      */
/*                          Revision: 1.00                           */
/*  This program is examples of program for TMP96C141, TMP96CM40,    */
/*  When you use this sample program, you must rewrite to fit your   */
/*  system. And please confirm that there is no mistake about        */
/*  generated object code.                                           */
/*===================================================================*/
/*     Copyright(C) TOSHIBA CORPORATION 2000  All rights reserved    */
/*===================================================================*/
/*===================================================================*/
/*  [ File include part ]                                            */
/*===================================================================*/
#include    "io900.h"    /* for the reference of I/O */
#include    <stdlib.h>   /* for '__EI()','abort()' and 'exit()' */

/*===================================================================*/
/* [ Prototype of function definition part ]                         */
/*   This part is necessary for main function calling.               */
/*===================================================================*/
void    main(void);         /* For main function calling */

/*===================================================================*/
/* [ Sample of initialize and EI and call main ]                     */
/*   This function is jumped from start up routine in 'stc96ml.mac'. */
/*   Rewrite this part to fit your program.                          */
/*===================================================================*/
void    _Initial(void){
  /*==  Write your initialize routine.      ==*/

  /*===[ Interrupt enable ]==========================================*/
  /*  __EI();                                                 SAMPLE */

  /*===[ Call main function ]========================================*/
  /*  main();                                                 SAMPLE */

  /*===[ Dummy Loop ]================================================*/
  /*  for(;;);                                                SAMPLE */
}

/*===================================================================*/
/* [ Sample of interrupt function ]                                  */
/*   Make interrupt routine to fit your program.                     */
/*===================================================================*/
/*===[ Sample for interrupt :                               ]========*/
/*===[       This function has only one instruction 'RETI'  ]========*/
void    __interrupt    _Int_dummy(void){
}

/*===================================================================*/
/* [ Define interrupt table ]                                        */
/*   Rewrite the base address of interrupt table to fit your target  */
/*   MCU. Write interrupt functions name you made, as initializer    */
/*   of table.                                                       */
/*===================================================================*/
#define  _SecInt_Name  inttbl     /* Section name of interrupt table */
#define  _BaseIntTbl   0x008000      /* Interrupt table base address */
#define  _SecInt_Attr  code /* Section attribute of interrrupt table */
void     _startup(void);    /* Prototype definition for reset vector */
                      /* This function is defined in a 'stc96ml.mac' */

#pragma  section  _SecInt_Attr  _SecInt_Name  _BaseIntTbl
void     __regbank(-1)   _INT_RESET(void){
    /* Reset/SWI0 */
    /* Write your codes here */
    /* __asm("    j    __startup"); */
}
#pragma  section  _SecInt_Attr  INTER1  0x8010
void     __regbank(-1)   _INT_PRIV(void){
    /* Privileged instruction/SWI1 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER2  0x8020
void     __regbank(-1)   _INT_UNDEF(void){
    /* Undefined instruction/SWI2 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER3  0x8030
void     __regbank(-1)   _INT_SWI3(void){
    /* SWI3 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER4  0x8040
void     __regbank(-1)   _INT_SWI4(void){
    /* SWI4 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER5  0x8050
void     __regbank(-1)   _INT_SWI5(void){
    /* SWI5 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER6  0x8060
void     __regbank(-1)   _INT_SWI6(void){
    /* SWI6 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER7  0x8070
void     __regbank(-1)   _INT_SWI7(void){
    /* SWI7 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER8  0x8080
void     __regbank(-1)   _INT_NMI(void){
    /* NMI */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER9  0x8090
void     __regbank(-1)   _INT_INTWD(void){
    /* Watch Dog Timer */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER10  0x80a0
void     __regbank(-1)   _INT_INT0(void){
    /* INT0 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER11  0x80b0
void     __regbank(-1)   _INT_INT4(void){
    /* INT4 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER12  0x80c0
void     __regbank(-1)   _INT_INT5(void){
    /* INT5 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER13  0x80d0
void     __regbank(-1)   _INT_INT6(void){
    /* INT6 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER14  0x80e0
void     __regbank(-1)   _INT_INT7(void){
    /* INT7 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER15  0x80f0
void     __regbank(-1)   _INT_RESERVED1(void){
    /* Reserved1 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER16  0x8100
void     __regbank(-1)   _INT_INTT0(void){
    /* INTT0 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER17  0x8110
void     __regbank(-1)   _INT_INTT1(void){
    /* INTT1 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER18  0x8120
void     __regbank(-1)   _INT_INTPW0(void){
    /* INTPW0 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER19  0x8130
void     __regbank(-1)   _INT_INTPW1(void){
    /* INTPW1 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER20  0x8140
void     __regbank(-1)   _INT_INTT4(void){
    /* INTT4 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER21  0x8150
void     __regbank(-1)   _INT_INTT5(void){
    /* INTT5 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER22  0x8160
void     __regbank(-1)   _INT_INTT6(void){
    /* INTT6 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER23  0x8170
void     __regbank(-1)   _INT_INTT7(void){
    /* INTT7 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER24  0x8180
void     __regbank(-1)   _INT_INTRX0(void){
    /* INTRX0 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER25  0x8190
void     __regbank(-1)   _INT_INTTX0(void){
    /* INTTX0 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER26  0x81a0
void     __regbank(-1)   _INT_INTRX1(void){
    /* INTRX1 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER27  0x81b0
void     __regbank(-1)   _INT_INTTX1(void){
    /* INTTX1 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER28  0x81c0
void     __regbank(-1)   _INT_INTAD(void){
    /* INTAD */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER29  0x81d0
void     __regbank(-1)   _INT_RESERVED2(void){
    /* Reserved2 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER30  0x81e0
void     __regbank(-1)   _INT_RESERVED3(void){
    /* Reserved3 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr  INTER31  0x81f0
void     __regbank(-1)   _INT_RESERVED4(void){
    /* Reserved4 */
    /* Write your codes here */
}
#pragma  section  _SecInt_Attr

/*===================================================================*/
/*      Standard C Library setting for TLCS-900  [ SAMPLE ]          */
/*                        [TMP96CM40/TMP96PM40]                      */
/*                          Revision: 1.00                           */
/*===================================================================*/
/*===================================================================*/
/* [ Configuration part ]                                            */
/*   Following macro value means that:                               */
/*   0 : The function is not used.                                   */
/*   1 : The function is used.                                       */
/*   When you use 'abort' or 'exit' or 'heap area',                  */
/*   Rewrite each program to fit your use.                           */
/*===================================================================*/
#define  __USE_FLOAT    0   /* Change 0 to 1, if use floating point. */
#define  __USE_ABORT    0   /* Change 0 to 1, if use abort function. */
#define  __USE_EXIT     0   /* Change 0 to 1, if use exit function.  */
#define  __USE_HEAP     0   /* Change 0 to 1, if use heap area.      */

#if __USE_FLOAT
/*===================================================================*/
/* [ Define public variable ]                                        */
/*  When use floating point, this part is necessary.                 */
/*  Do not change this part.                                         */
/*  'errno' is reserved word. Do not access to this variable.        */
/*===================================================================*/
int     errno;                        /* Refer from standard library */

#endif      /* __USE_FLOAT */

#if __USE_ABORT
/*===================================================================*/
/* [ Standard library function: abort() ]                            */
/*   When use abort function, this part is necessary.                */
/*   Rewrite this part to fit your program.                          */
/*===================================================================*/
void    abort(void){
  /*=================================================================*/
  /*  Write the process before reset, then jump to your start up     */
  /*  routine.                                                       */
  /*=================================================================*/
  /*  __asm("    j    __startup");                            SAMPLE */
  /*=================================================================*/
}
#endif      /* __USE_ABORT */

#if __USE_EXIT
/*===================================================================*/
/* [ Standard library function: exit() ]                             */
/*   When use exit function, this part is necessary.                 */
/*   Rewrite this part to fit your program.                          */
/*===================================================================*/
void    exit(int status){
  /*=================================================================*/
  /*  Write the process as same as normal program ending.            */
  /*=================================================================*/
  /*  __asm("    halt");                                      SAMPLE */
  /*=================================================================*/
}
#endif      /* __USE_EXIT */

#if __USE_HEAP
/*===================================================================*/
/* [ Define Heap area ]                                              */
/*   When use malloc, calloc or realloc, this part is necessary.     */
/*   Rewrite the address and size of Heap area to fit your program.  */
/*===================================================================*/
#define  HeapTop   (void*)0x4000  /* Heap area top address */
#define  HeapSize  0x4000         /* Heap area size */
void*    SBRK_break = HeapTop;    /* Set Heap area top address */
int      SBRK_size = HeapSize;    /* Set Heap area size */
void*    _allocb=((void *)0);     /* Memory management pointer */

#endif      /* __USE_HEAP */

/* End of file */
