/****************************************************************
 *		TLCS-900 C Compiler Header File			*
 *--------------------------------------------------------------*
 *	[For]		{TMP91CW12}				*
 *	[File name]	{IO900L1.H}				*
 *	[Subject]	{Special Function Registers}		*
 *  Copyright(C) TOSHIBA CORPORATION 1999  All rights reserved  *
 ****************************************************************/

/***[0x00]*************************************************************************/
#pragma io	IOP0		0x00	/* 0x00: Port0 */
#pragma io	IOP1		0x01	/* 0x01: Port1 */
#pragma io	P0CR		0x02	/* 0x02: Port0 control */
/*---undefined---*/			/* 0x03: */
#pragma io	P1CR		0x04	/* 0x04: Port1 control */
#pragma io	P1FC		0x05	/* 0x05: Port1 function */
#pragma io	IOP2		0x06	/* 0x06: Port2 */
#pragma io	IOP3		0x07	/* 0x07: Port3 */
#pragma io	P2CR		0x08	/* 0x08: Port2 control */
#pragma io	P2FC		0x09	/* 0x09: Port2 function */
#pragma io	P3CR		0x0a	/* 0x0a: Port3 control */
#pragma io	P3FC		0x0b	/* 0x0b: Port3 function */
#pragma io	IOP4		0x0c	/* 0x0c: Port4 */
#pragma io	IOP5		0x0d	/* 0x0d: Port5 */
#pragma io	P4CR		0x0e	/* 0x0e: Port4 control */
#pragma io	P4FC		0x0f	/* 0x0f: Port4 function */

/***[0x10]*************************************************************************/
/*---undefined---*/			/* 0x10: */
/*---undefined---*/			/* 0x11: */
#pragma io	IOP6		0x12	/* 0x12: Port6 */
#pragma io	IOP7		0x13	/* 0x13: Port7 */
#pragma io	P6CR		0x14	/* 0x14: Port6 control */
#pragma io	P6FC		0x15	/* 0x15: Port6 function */
#pragma io	P7CR		0x16	/* 0x16: Port7 control */
#pragma io	P7FC		0x17	/* 0x17: Port7 function */
#pragma io	IOP8		0x18	/* 0x18: Port8 */
#pragma io	IOP9		0x19	/* 0x19: Port9 */
#pragma io	P8CR		0x1a	/* 0x1a: Port8 control */
#pragma io	P8FC		0x1b	/* 0x1b: Port8 function */
#pragma io	P9CR		0x1c	/* 0x1c: Port9 control */
#pragma io	P9FC		0x1d	/* 0x1d: Port9 function */
#pragma io	IOPA		0x1e	/* 0x1e: PortA */
/*---undefined---*/			/* 0x1f: */

/***[0x20]*************************************************************************/
#pragma io	PACR		0x20	/* 0x20: PortA control */
#pragma io	PAFC		0x21	/* 0x21: PortA function */
/*---undefined---*/			/* 0x22: */
/*---undefined---*/			/* 0x23: */
/*---undefined---*/			/* 0x24: */
/*---undefined---*/			/* 0x25: */
/*---undefined---*/			/* 0x26: */
/*---undefined---*/			/* 0x27: */
/*---undefined---*/			/* 0x28: */
/*---undefined---*/			/* 0x29: */
/*---undefined---*/			/* 0x2a: */
/*---undefined---*/			/* 0x2b: */
/*---undefined---*/			/* 0x2c: */
/*---undefined---*/			/* 0x2d: */
/*---undefined---*/			/* 0x2e: */
#pragma io	ODE		0x2f	/* 0x2f: Serial out control */

/***[0x80]*************************************************************************/
#pragma io	DMA0V		0x80	/* 0x80: DMA0 Start vector register */
#pragma io	DMA1V		0x81	/* 0x81: DMA1 Start vector register */
#pragma io	DMA2V		0x82	/* 0x82: DMA2 Start vector register */
#pragma io	DMA3V		0x83	/* 0x83: DMA3 Start vector register */
/*---undefined---*/			/* 0x84: */
/*---undefined---*/			/* 0x85: */
/*---undefined---*/			/* 0x86: */
/*---undefined---*/			/* 0x87: */
#pragma io	INTCLR		0x88	/* 0x88: Interrupt clear control register */
#pragma io	DMAR		0x89	/* 0x89: DMA Software request register */
#pragma io	DMAB		0x8a	/* 0x8a: DMA Burst register */
/*---undefined---*/			/* 0x8b: */
#pragma io	IIMC		0x8c	/* 0x8c: Interrupt input mode control register */
/*---undefined---*/			/* 0x8d: */
/*---undefined---*/			/* 0x8e: */
/*---undefined---*/			/* 0x8f: */

/***[0x90]*************************************************************************/
#pragma io	INTE0AD		0x90	/* 0x90: Interrupt priority setting register */
#pragma io	INTE12		0x91	/* 0x91: Interrupt priority setting register */
#pragma io	INTE34		0x92	/* 0x92: Interrupt priority setting register */
#pragma io	INTE56		0x93	/* 0x93: Interrupt priority setting register */
#pragma io	INTE78		0x94	/* 0x94: Interrupt priority setting register */
#pragma io	INTETA01	0x95	/* 0x95: Interrupt priority setting register */
#pragma io	INTETA23	0x96	/* 0x96: Interrupt priority setting register */
#pragma io	INTETA45	0x97	/* 0x97: Interrupt priority setting register */
#pragma io	INTETA67	0x98	/* 0x98: Interrupt priority setting register */
#pragma io	INTETB0		0x99	/* 0x99: Interrupt priority setting register */
#pragma io	INTETB1		0x9a	/* 0x9a: Interrupt priority setting register */
#pragma io	INTETB01V	0x9b	/* 0x9b: Interrupt priority setting register */
#pragma io	INTES0		0x9c	/* 0x9c: Interrupt priority setting register */
#pragma io	INTES1		0x9d	/* 0x9d: Interrupt priority setting register */
#pragma io	INTES2RTC	0x9e	/* 0x9e: Interrupt priority setting register */
/*---undefined---*/			/* 0x9f: */

/***[0xA0]*************************************************************************/
#pragma io	INTETC01	0xa0	/* 0xa0: Interrupt priority setting register */
#pragma io	INTETC23	0xa1	/* 0xa1: Interrupt priority setting register */
/*---undefined---*/			/* 0xa2: */
/*---undefined---*/			/* 0xa3: */
/*---undefined---*/			/* 0xa4: */
/*---undefined---*/			/* 0xa5: */
/*---undefined---*/			/* 0xa6: */
/*---undefined---*/			/* 0xa7: */
/*---undefined---*/			/* 0xa8: */
/*---undefined---*/			/* 0xa9: */
/*---undefined---*/			/* 0xaa: */
/*---undefined---*/			/* 0xab: */
/*---undefined---*/			/* 0xac: */
/*---undefined---*/			/* 0xad: */
/*---undefined---*/			/* 0xae: */
/*---undefined---*/			/* 0xaf: */

/***[0xC0]*************************************************************************/
#pragma io	B0CS		0xc0	/* 0xc0: Chip select/Wait control register(CS0) */
#pragma io	B1CS		0xc1	/* 0xc1: Chip select/Wait control register(CS1) */
#pragma io	B2CS		0xc2	/* 0xc2: Chip select/Wait control register(CS2) */
#pragma io	B3CS		0xc3	/* 0xc3: Chip select/Wait control register(CS3) */
/*---undefined---*/			/* 0xc4: */
/*---undefined---*/			/* 0xc5: */
/*---undefined---*/			/* 0xc6: */
#pragma io	BEXCS		0xc7	/* 0xc7: Chip select/Wait control register(others) */
#pragma io	MSAR0		0xc8	/* 0xc8: Memory start address register(CS0) */
#pragma io	MAMR0		0xc9	/* 0xc9: Memory address mask register (CS0) */
#pragma io	MSAR1		0xca	/* 0xca: Memory start address register(CS1) */
#pragma io	MAMR1		0xcb	/* 0xcb: Memory address mask register (CS1) */
#pragma io	MSAR2		0xcc	/* 0xcc: Memory start address register(CS2) */
#pragma io	MAMR2		0xcd	/* 0xcd: Memory address mask register (CS2) */
#pragma io	MSAR3		0xce	/* 0xce: Memory start address register(CS3) */
#pragma io	MAMR3		0xcf	/* 0xcf: Memory address mask register (CS3) */

/***[0xE0]*************************************************************************/
#pragma io	SYSCR0		0xe0	/* 0xe0: SFR for system clock */
#pragma io	SYSCR1		0xe1	/* 0xe1: SFR for system clock */
#pragma io	SYSCR2		0xe2	/* 0xe2: SFR for system clock */
#pragma io	EMCCR0		0xe3	/* 0xe3: SFR for noise-reducing */
#pragma io	EMCCR1		0xe4	/* 0xe4: SFR for noise-reducing */
/*---undefined---*/			/* 0xe5: */
/*---undefined---*/			/* 0xe6: */
/*---undefined---*/			/* 0xe7: */
#pragma io	DFMCR0		0xe8	/* 0xe8: SFR for DFM */
/*---undefined---*/			/* 0xe9: */
/*---undefined---*/			/* 0xea: */
/*---undefined---*/			/* 0xeb: */
/*---undefined---*/			/* 0xec: */
/*---undefined---*/			/* 0xed: */
/*---undefined---*/			/* 0xee: */
/*---undefined---*/			/* 0xef: */

/***[0xF0]*************************************************************************/
/*---undefined---*/			/* 0xf1: */
/*---undefined---*/			/* 0xf2: */
/*---undefined---*/			/* 0xf3: */
/*---undefined---*/			/* 0xf4: */
/*---undefined---*/			/* 0xf5: */
/*---undefined---*/			/* 0xf6: */
/*---undefined---*/			/* 0xf7: */
/*---undefined---*/			/* 0xf8: */
/*---undefined---*/			/* 0xf9: */
/*---undefined---*/			/* 0xfa: */
/*---undefined---*/			/* 0xfb: */
/*---undefined---*/			/* 0xfc: */
/*---undefined---*/			/* 0xfd: */
/*---undefined---*/			/* 0xfe: */
/*---undefined---*/			/* 0xff: */

/***[0x100]************************************************************************/
#pragma io	TA01RUN		0x100	/* 0x100: TMRA01 RUN register */
/*---undefined---*/			/* 0x101: */
#pragma io	TA0REG		0x102	/* 0x102: Timer register0 */
#pragma io	TA1REG		0x103	/* 0x103: Timer register1 */
#pragma io	TA01MOD		0x104	/* 0x104: TMRA01 Mode register */
#pragma io	TA1FFCR		0x105	/* 0x105: TMRA1 Flip-flop control register */
/*---undefined---*/			/* 0x106: */
/*---undefined---*/			/* 0x107: */
#pragma io	TA23RUN		0x108	/* 0x108: TMRA23 RUN register */
/*---undefined---*/			/* 0x109: */
#pragma io	TA2REG		0x10a	/* 0x10a: Timer register2 */
#pragma io	TA3REG		0x10b	/* 0x10b: Timer register3 */
#pragma io	TA23MOD		0x10c	/* 0x10c: TMRA23 Mode register */
#pragma io	TA3FFCR		0x10d	/* 0x10d: TMRA3 Flip-flop control register */
/*---undefined---*/			/* 0x10e: */
/*---undefined---*/			/* 0x10f: */

/***[0x110]************************************************************************/
#pragma io	TA45RUN		0x110	/* 0x110: TMRA45 RUN register */
/*---undefined---*/			/* 0x111: */
#pragma io	TA4REG		0x112	/* 0x112: Timer register4 */
#pragma io	TA5REG		0x113	/* 0x113: Timer register5 */
#pragma io	TA45MOD		0x114	/* 0x114: TMRA45 Mode register */
#pragma io	TA5FFCR		0x115	/* 0x115: TMRA5 Flip-flop control register */
/*---undefined---*/			/* 0x116: */
/*---undefined---*/			/* 0x117: */
#pragma io	TA67RUN		0x118	/* 0x118: TMRA67 RUN register */
/*---undefined---*/			/* 0x119: */
#pragma io	TA6REG		0x11a	/* 0x10a: Timer register6 */
#pragma io	TA7REG		0x11b	/* 0x10b: Timer register7 */
#pragma io	TA67MOD		0x11c	/* 0x11c: TMRA67 Mode register */
#pragma io	TA7FFCR		0x11d	/* 0x11d: TMRA7 Flip-flop control register */
/*---undefined---*/			/* 0x11e: */
/*---undefined---*/			/* 0x11f: */

/***[0x180]************************************************************************/
#pragma io	TB0RUN		0x180	/* 0x180: TMRB0 RUN register */
/*---undefined---*/			/* 0x181: */
#pragma io	TB0MOD		0x182	/* 0x182: TMRB0 Mode register */
#pragma io	TB0FFCR		0x183	/* 0x183: TMRB0 Flip-flop control register */
/*---undefined---*/			/* 0x184: */
/*---undefined---*/			/* 0x185: */
/*---undefined---*/			/* 0x186: */
/*---undefined---*/			/* 0x187: */
/*#pragma io	TB0RG0		0x188 */	/* 0x188: TMRB0 Timer register0 */
#pragma io	TB0RG0L		0x188	   		/* 0x188: TMRB0 Timer register0[low] */
#pragma io	TB0RG0H		0x189	   		/* 0x189: TMRB0 Timer register0[high] */
/*#pragma io	TB0RG1		0x18a */	/* 0x18a: TMRB0 Timer register1 */
#pragma io	TB0RG1L		0x18a	   		/* 0x18a: TMRB0 Timer register1[low] */
#pragma io	TB0RG1H		0x18b	   		/* 0x18b: TMRB0 Timer register1[high] */
/*#pragma io	TB0CP0		0x18c */	/* 0x18c: TMRB0 Capture register0 */
#pragma io	TB0CP0L		0x18c	   		/* 0x18c: TMRB0 Capture register0[low] */
#pragma io	TB0CP0H		0x18d	   		/* 0x18d: TMRB0 Capture register0[high] */
/*#pragma io	TB0CP1		0x18e */	/* 0x18e: TMRB0 Capture register1 */
#pragma io	TB0CP1L		0x18e	   		/* 0x18e: TMRB0 Capture register1[low] */
#pragma io	TB0CP1H		0x18f	   		/* 0x18f: TMRB0 Capture register1[high] */

/***[0x190]************************************************************************/
#pragma io	TB1RUN		0x190	/* 0x190: TMRB1 RUN register */
/*---undefined---*/			/* 0x191: */
#pragma io	TB1MOD		0x192	/* 0x192: TMRB1 Mode register */
#pragma io	TB1FFCR		0x193	/* 0x193: TMRB1 Flip-flop control register */
/*---undefined---*/			/* 0x194: */
/*---undefined---*/			/* 0x195: */
/*---undefined---*/			/* 0x196: */
/*---undefined---*/			/* 0x197: */
/*#pragma io	TB1RG0		0x198 */	/* 0x198: TMRB1 Timer register0 */
#pragma io	TB1RG0L		0x198	   		/* 0x198: TMRB1 Timer register0[low] */
#pragma io	TB1RG0H		0x199	   		/* 0x199: TMRB1 Timer register0[high] */
/*#pragma io	TB1RG1		0x19a */	/* 0x19a: TMRB1 Timer register1 */
#pragma io	TB1RG1L		0x19a	   		/* 0x19a: TMRB1 Timer register1[low] */
#pragma io	TB1RG1H		0x19b	   		/* 0x19b: TMRB1 Timer register1[high] */
/*#pragma io	TB1CP0		0x19c */	/* 0x19c: TMRB1 Capture register0 */
#pragma io	TB1CP0L		0x19c	   		/* 0x19c: TMRB1 Capture register0[low] */
#pragma io	TB1CP0H		0x19d	   		/* 0x19d: TMRB1 Capture register0[high] */
/*#pragma io	TB1CP1		0x19e */	/* 0x19e: TMRB1 Capture register1 */
#pragma io	TB1CP1L		0x19e	   		/* 0x19e: TMRB1 Capture register1[low] */
#pragma io	TB1CP1H		0x19f	   		/* 0x19f: TMRB1 Capture register1[high] */

/***[0x200]************************************************************************/
#pragma io	SC0BUF		0x200	/* 0x200: Serial transmission/Receiving buffer register(SIO0) */
#pragma io	SC0CR		0x201	/* 0x201: Serial control register(SIO0) */
#pragma io	SC0MOD0		0x202	/* 0x202: Serial mode control register0(SIO0) */
#pragma io	BR0CR		0x203	/* 0x203: Baud rate generator control register(SIO0) */
#pragma io	BR0ADD		0x204	/* 0x204: Baud rate generator control register(SIO0) */
#pragma io	SC0MOD1		0x205	/* 0x205: Serial mode control register1(SIO0) */
/*---undefined---*/			/* 0x206: */
#pragma io	SIRCR		0x207	/* 0x207: IrDA control register */
#pragma io	SC1BUF		0x208	/* 0x208: Serial transmission/Receiving buffer register(SIO1) */
#pragma io	SC1CR		0x209	/* 0x209: Serial control register(SIO1) */
#pragma io	SC1MOD0		0x20a	/* 0x20a: Serial mode control register0(SIO1) */
#pragma io	BR1CR		0x20b	/* 0x20b: Baud rate generator control register(SIO1) */
#pragma io	BR1ADD		0x20c	/* 0x20c: Baud rate generator control register(SIO1) */
#pragma io	SC1MOD1		0x20d	/* 0x20d: Serial mode control register1(SIO1) */
/*---undefined---*/			/* 0x20e: */
/*---undefined---*/			/* 0x20f: */

/***[0x240]************************************************************************/
#pragma io	SBI0CR1		0x240	/* 0x240: Serial bus interface control register1 */
#pragma io	SBI0DBR		0x241	/* 0x241: Serial bus interface data buffer register */
#pragma io	I2C0AR		0x242	/* 0x242: I2C Bus address register */
#pragma io	SBI0CR2		0x243	/* 0x243: Serial bus interface control register2 */
/*#pragma io	SBI0SR		0x243 */ /*  0x243: Serial bus interface status register */
#pragma io	SBI0BR0		0x244	/* 0x244: Serial bus interface baud rate register0 */
#pragma io	SBI0BR1		0x245	/* 0x245: Serial bus interface baud rate register1 */
/*---undefined---*/			/* 0x246: */
/*---undefined---*/			/* 0x247: */
/*---undefined---*/			/* 0x248: */
/*---undefined---*/			/* 0x249: */
/*---undefined---*/			/* 0x24a: */
/*---undefined---*/			/* 0x24b: */
/*---undefined---*/			/* 0x24c: */
/*---undefined---*/			/* 0x24d: */
/*---undefined---*/			/* 0x24e: */
/*---undefined---*/			/* 0x24f: */

/***[0x2A0]************************************************************************/
#pragma io	ADREG04L	0x2a0	/* 0x2a0: A/D Conversion data lower register0/4 */
#pragma io	ADREG04H	0x2a1	/* 0x2a1: A/D Conversion data upper register0/4 */
#pragma io	ADREG15L	0x2a2	/* 0x2a2: A/D Conversion data lower register1/5 */
#pragma io	ADREG15H	0x2a3	/* 0x2a3: A/D Conversion data upper register1/5 */
#pragma io	ADREG26L	0x2a4	/* 0x2a4: A/D Conversion data lower register2/6 */
#pragma io	ADREG26H	0x2a5	/* 0x2a5: A/D Conversion data upper register2/6 */
#pragma io	ADREG37L	0x2a6	/* 0x2a6: A/D Conversion data lower register3/7 */
#pragma io	ADREG37H	0x2a7	/* 0x2a7: A/D Conversion data upper register3/7 */
/*---undefined---*/			/* 0x2a8: */
/*---undefined---*/			/* 0x2a9: */
/*---undefined---*/			/* 0x2aa: */
/*---undefined---*/			/* 0x2ab: */
/*---undefined---*/			/* 0x2ac: */
/*---undefined---*/			/* 0x2ad: */
/*---undefined---*/			/* 0x2af: */

/***[0x2B0]************************************************************************/
#pragma io	ADMOD0		0x2b0	/* 0x2b0: A/D Mode control register0 */
#pragma io	ADMOD1		0x2b1	/* 0x2b1: A/D Mode control register1 */
/*---undefined---*/			/* 0x2b2: */
/*---undefined---*/			/* 0x2b3: */
/*---undefined---*/			/* 0x2b4: */
/*---undefined---*/			/* 0x2b5: */
/*---undefined---*/			/* 0x2b6: */
/*---undefined---*/			/* 0x2b7: */
/*---undefined---*/			/* 0x2b8: */
/*---undefined---*/			/* 0x2b9: */
/*---undefined---*/			/* 0x2ba: */
/*---undefined---*/			/* 0x2bb: */
/*---undefined---*/			/* 0x2bc: */
/*---undefined---*/			/* 0x2bd: */
/*---undefined---*/			/* 0x2bf: */

/***[0x300]************************************************************************/
#pragma io	WDMOD		0x300	/* 0x300: Watchdog timer mode register */
#pragma io	WDCR		0x301	/* 0x301: Watchdog timer control register */
/*---undefined---*/			/* 0x302: */
/*---undefined---*/			/* 0x303: */
/*---undefined---*/			/* 0x304: */
/*---undefined---*/			/* 0x305: */
/*---undefined---*/			/* 0x306: */
/*---undefined---*/			/* 0x307: */
/*---undefined---*/			/* 0x308: */
/*---undefined---*/			/* 0x309: */
/*---undefined---*/			/* 0x30a: */
/*---undefined---*/			/* 0x30b: */
/*---undefined---*/			/* 0x30c: */
/*---undefined---*/			/* 0x30d: */
/*---undefined---*/			/* 0x30e: */
/*---undefined---*/			/* 0x30f: */

/***[0x310]************************************************************************/
#pragma io	RTCCR		0x310	/* 0x310: Timer for real time clock control register */
/*---undefined---*/			/* 0x311: */
/*---undefined---*/			/* 0x312: */
/*---undefined---*/			/* 0x313: */
/*---undefined---*/			/* 0x314: */
/*---undefined---*/			/* 0x315: */
/*---undefined---*/			/* 0x316: */
/*---undefined---*/			/* 0x317: */
/*---undefined---*/			/* 0x318: */
/*---undefined---*/			/* 0x319: */
/*---undefined---*/			/* 0x31a: */
/*---undefined---*/			/* 0x31b: */
/*---undefined---*/			/* 0x31c: */
/*---undefined---*/			/* 0x31d: */
/*---undefined---*/			/* 0x31e: */
/*---undefined---*/			/* 0x31f: */

/***[0x00]*************************************************************************/
extern unsigned char  IOP0;		/* 0x00: Port0 */
extern unsigned char  IOP1;		/* 0x01: Port1 */
extern unsigned char  P0CR;		/* 0x02: Port0 control */
/*---undefined---*/			/* 0x03: */
extern unsigned char  P1CR;		/* 0x04: Port1 control */
extern unsigned char  P1FC;		/* 0x05: Port1 function */
extern unsigned char  IOP2;		/* 0x06: Port2 */
extern unsigned char  IOP3;		/* 0x07: Port3 */
extern unsigned char  P2CR;		/* 0x08: Port2 control */
extern unsigned char  P2FC;		/* 0x09: Port2 function */
extern unsigned char  P3CR;		/* 0x0a: Port3 control */
extern unsigned char  P3FC;		/* 0x0b: Port3 function */
extern unsigned char  IOP4;		/* 0x0c: Port4 */
extern unsigned char  IOP5;		/* 0x0d: Port5 */
extern unsigned char  P4CR;		/* 0x0e: Port4 control */
extern unsigned char  P4FC;		/* 0x0f: Port4 function */

/***[0x10]*************************************************************************/
/*---undefined---*/			/* 0x10: */
/*---undefined---*/			/* 0x11: */
extern unsigned char  IOP6;		/* 0x12: Port6 */
extern unsigned char  IOP7;		/* 0x13: Port7 */
extern unsigned char  P6CR;		/* 0x14: Port6 control */
extern unsigned char  P6FC;		/* 0x15: Port6 function */
extern unsigned char  P7CR;		/* 0x16: Port7 control */
extern unsigned char  P7FC;		/* 0x17: Port7 function */
extern unsigned char  IOP8;		/* 0x18: Port8 */
extern unsigned char  IOP9;		/* 0x19: Port9 */
extern unsigned char  P8CR;		/* 0x1a: Port8 control */
extern unsigned char  P8FC;		/* 0x1b: Port8 function */
extern unsigned char  P9CR;		/* 0x1c: Port9 control */
extern unsigned char  P9FC;		/* 0x1d: Port9 function */
extern unsigned char  IOPA;		/* 0x1e: PortA */
/*---undefined---*/			/* 0x1f: */

/***[0x20]*************************************************************************/
extern unsigned char  PACR;		/* 0x20: PortA control */
extern unsigned char  PAFC;		/* 0x21: PortA function */
/*---undefined---*/			/* 0x22: */
/*---undefined---*/			/* 0x23: */
/*---undefined---*/			/* 0x24: */
/*---undefined---*/			/* 0x25: */
/*---undefined---*/			/* 0x26: */
/*---undefined---*/			/* 0x27: */
/*---undefined---*/			/* 0x28: */
/*---undefined---*/			/* 0x29: */
/*---undefined---*/			/* 0x2a: */
/*---undefined---*/			/* 0x2b: */
/*---undefined---*/			/* 0x2c: */
/*---undefined---*/			/* 0x2d: */
/*---undefined---*/			/* 0x2e: */
extern unsigned char  ODE;		/* 0x2f: Serial out control */

/***[0x80]*************************************************************************/
extern unsigned char  DMA0V;		/* 0x80: DMA0 Start vector register */
extern unsigned char  DMA1V;		/* 0x81: DMA1 Start vector register */
extern unsigned char  DMA2V;		/* 0x82: DMA2 Start vector register */
extern unsigned char  DMA3V;		/* 0x83: DMA3 Start vector register */
/*---undefined---*/			/* 0x84: */
/*---undefined---*/			/* 0x85: */
/*---undefined---*/			/* 0x86: */
/*---undefined---*/			/* 0x87: */
extern unsigned char  INTCLR;		/* 0x88: Interrupt clear control register */
extern unsigned char  DMAR;		/* 0x89: DMA Software request register */
extern unsigned char  DMAB;		/* 0x8a: DMA Burst register */
/*---undefined---*/			/* 0x8b: */
extern unsigned char  IIMC;		/* 0x8c: Interrupt input mode control register */
/*---undefined---*/			/* 0x8d: */
/*---undefined---*/			/* 0x8e: */
/*---undefined---*/			/* 0x8f: */

/***[0x90]*************************************************************************/
extern unsigned char  INTE0AD;		/* 0x90: Interrupt priority setting register */
extern unsigned char  INTE12;		/* 0x91: Interrupt priority setting register */
extern unsigned char  INTE34;		/* 0x92: Interrupt priority setting register */
extern unsigned char  INTE56;		/* 0x93: Interrupt priority setting register */
extern unsigned char  INTE78;		/* 0x94: Interrupt priority setting register */
extern unsigned char  INTETA01;		/* 0x95: Interrupt priority setting register */
extern unsigned char  INTETA23;		/* 0x96: Interrupt priority setting register */
extern unsigned char  INTETA45;		/* 0x97: Interrupt priority setting register */
extern unsigned char  INTETA67;		/* 0x98: Interrupt priority setting register */
extern unsigned char  INTETB0;		/* 0x99: Interrupt priority setting register */
extern unsigned char  INTETB1;		/* 0x9a: Interrupt priority setting register */
extern unsigned char  INTETB01V;	/* 0x9b: Interrupt priority setting register */
extern unsigned char  INTES0;		/* 0x9c: Interrupt priority setting register */
extern unsigned char  INTES1;		/* 0x9d: Interrupt priority setting register */
extern unsigned char  INTES2RTC;	/* 0x9e: Interrupt priority setting register */
/*---undefined---*/			/* 0x9f: */

/***[0xA0]*************************************************************************/
extern unsigned char  INTETC01;		/* 0xa0: Interrupt priority setting register */
extern unsigned char  INTETC23;		/* 0xa1: Interrupt priority setting register */
/*---undefined---*/			/* 0xa2: */
/*---undefined---*/			/* 0xa3: */
/*---undefined---*/			/* 0xa4: */
/*---undefined---*/			/* 0xa5: */
/*---undefined---*/			/* 0xa6: */
/*---undefined---*/			/* 0xa7: */
/*---undefined---*/			/* 0xa8: */
/*---undefined---*/			/* 0xa9: */
/*---undefined---*/			/* 0xaa: */
/*---undefined---*/			/* 0xab: */
/*---undefined---*/			/* 0xac: */
/*---undefined---*/			/* 0xad: */
/*---undefined---*/			/* 0xae: */
/*---undefined---*/			/* 0xaf: */

/***[0xC0]*************************************************************************/
extern unsigned char  B0CS;		/* 0xc0: Chip select/Wait control register(CS0) */
extern unsigned char  B1CS;		/* 0xc1: Chip select/Wait control register(CS1) */
extern unsigned char  B2CS;		/* 0xc2: Chip select/Wait control register(CS2) */
extern unsigned char  B3CS;		/* 0xc3: Chip select/Wait control register(CS3) */
/*---undefined---*/			/* 0xc4: */
/*---undefined---*/			/* 0xc5: */
/*---undefined---*/			/* 0xc6: */
extern unsigned char  BEXCS;		/* 0xc7: Chip select/Wait control register(others) */
extern unsigned char  MSAR0;		/* 0xc8: Memory start address register(CS0) */
extern unsigned char  MAMR0;		/* 0xc9: Memory address mask register (CS0) */
extern unsigned char  MSAR1;		/* 0xca: Memory start address register(CS1) */
extern unsigned char  MAMR1;		/* 0xcb: Memory address mask register (CS1) */
extern unsigned char  MSAR2;		/* 0xcc: Memory start address register(CS2) */
extern unsigned char  MAMR2;		/* 0xcd: Memory address mask register (CS2) */
extern unsigned char  MSAR3;		/* 0xce: Memory start address register(CS3) */
extern unsigned char  MAMR3;		/* 0xcf: Memory address mask register (CS3) */

/***[0xE0]*************************************************************************/
extern unsigned char  SYSCR0;		/* 0xe0: SFR for system clock */
extern unsigned char  SYSCR1;		/* 0xe1: SFR for system clock */
extern unsigned char  SYSCR2;		/* 0xe2: SFR for system clock */
extern unsigned char  EMCCR0;		/* 0xe3: SFR for noise-reducing */
extern unsigned char  EMCCR1;		/* 0xe4: SFR for noise-reducing */
/*---undefined---*/			/* 0xe5: */
/*---undefined---*/			/* 0xe6: */
/*---undefined---*/			/* 0xe7: */
extern unsigned char  DFMCR0;		/* 0xe8: SFR for DFM */
/*---undefined---*/			/* 0xe9: */
/*---undefined---*/			/* 0xea: */
/*---undefined---*/			/* 0xeb: */
/*---undefined---*/			/* 0xec: */
/*---undefined---*/			/* 0xed: */
/*---undefined---*/			/* 0xee: */
/*---undefined---*/			/* 0xef: */

/***[0xF0]*************************************************************************/
/*---undefined---*/			/* 0xf1: */
/*---undefined---*/			/* 0xf2: */
/*---undefined---*/			/* 0xf3: */
/*---undefined---*/			/* 0xf4: */
/*---undefined---*/			/* 0xf5: */
/*---undefined---*/			/* 0xf6: */
/*---undefined---*/			/* 0xf7: */
/*---undefined---*/			/* 0xf8: */
/*---undefined---*/			/* 0xf9: */
/*---undefined---*/			/* 0xfa: */
/*---undefined---*/			/* 0xfb: */
/*---undefined---*/			/* 0xfc: */
/*---undefined---*/			/* 0xfd: */
/*---undefined---*/			/* 0xfe: */
/*---undefined---*/			/* 0xff: */

/***[0x100]************************************************************************/
extern unsigned char  TA01RUN;		/* 0x100: TMRA01 RUN register */
/*---undefined---*/			/* 0x101: */
extern unsigned char  TA0REG;		/* 0x102: Timer register0 */
extern unsigned char  TA1REG;		/* 0x103: Timer register1 */
extern unsigned char  TA01MOD;		/* 0x104: TMRA01 Mode register */
extern unsigned char  TA1FFCR;		/* 0x105: TMRA1 Flip-flop control register */
/*---undefined---*/			/* 0x106: */
/*---undefined---*/			/* 0x107: */
extern unsigned char  TA23RUN;		/* 0x108: TMRA23 RUN register */
/*---undefined---*/			/* 0x109: */
extern unsigned char  TA2REG;		/* 0x10a: Timer register2 */
extern unsigned char  TA3REG;		/* 0x10b: Timer register3 */
extern unsigned char  TA23MOD;		/* 0x10c: TMRA23 Mode register */
extern unsigned char  TA3FFCR;		/* 0x10d: TMRA3 Flip-flop control register */
/*---undefined---*/			/* 0x10e: */
/*---undefined---*/			/* 0x10f: */

/***[0x110]************************************************************************/
extern unsigned char  TA45RUN;		/* 0x110: TMRA45 RUN register */
/*---undefined---*/			/* 0x111: */
extern unsigned char  TA4REG;		/* 0x112: Timer register4 */
extern unsigned char  TA5REG;		/* 0x113: Timer register5 */
extern unsigned char  TA45MOD;		/* 0x114: TMRA45 Mode register */
extern unsigned char  TA5FFCR;		/* 0x115: TMRA5 Flip-flop control register */
/*---undefined---*/			/* 0x116: */
/*---undefined---*/			/* 0x117: */
extern unsigned char  TA67RUN;		/* 0x118: TMRA67 RUN register */
/*---undefined---*/			/* 0x119: */
extern unsigned char  TA6REG;		/* 0x11a: Timer register6 */
extern unsigned char  TA7REG;		/* 0x11b: Timer register7 */
extern unsigned char  TA67MOD;		/* 0x11c: TMRA67 Mode register */
extern unsigned char  TA7FFCR;		/* 0x11d: TMRA7 Flip-flop control register */
/*---undefined---*/			/* 0x11e: */
/*---undefined---*/			/* 0x11f: */

/***[0x180]************************************************************************/
extern unsigned char  TB0RUN;		/* 0x180: TMRB0 RUN register */
/*---undefined---*/			/* 0x181: */
extern unsigned char  TB0MOD;		/* 0x182: TMRB0 Mode register */
extern unsigned char  TB0FFCR;		/* 0x183: TMRB0 Flip-flop control register */
/*---undefined---*/			/* 0x184: */
/*---undefined---*/			/* 0x185: */
/*---undefined---*/			/* 0x186: */
/*---undefined---*/			/* 0x187: */
/* extern unsigned int	TB0RG0;	*/	/* 0x188: TMRB0 Timer register0 */
extern unsigned char  TB0RG0L;	   	/* 0x188: TMRB0 Timer register0[low] */
extern unsigned char  TB0RG0H;	   	/* 0x189: TMRB0 Timer register0[high] */
/* extern unsigned int	TB0RG1;	*/	/* 0x18a: TMRB0 Timer register1 */
extern unsigned char  TB0RG1L;	   	/* 0x18a: TMRB0 Timer register1[low] */
extern unsigned char  TB0RG1H;	   	/* 0x18b: TMRB0 Timer register1[high] */
/* extern unsigned int	TB0CP0;	*/	/* 0x18c: TMRB0 Capture register0 */
extern unsigned char  TB0CP0L;	   	/* 0x18c: TMRB0 Capture register0[low] */
extern unsigned char  TB0CP0H;	   	/* 0x18d: TMRB0 Capture register0[high] */
/* extern unsigned int	TB0CP1;	*/	/* 0x18e: TMRB0 Capture register1 */
extern unsigned char  TB0CP1L;	   	/* 0x18e: TMRB0 Capture register1[low] */
extern unsigned char  TB0CP1H;	   	/* 0x18f: TMRB0 Capture register1[high] */

/***[0x190]************************************************************************/
extern unsigned char  TB1RUN;		/* 0x190: TMRB1 RUN register */
/*---undefined---*/			/* 0x191: */
extern unsigned char  TB1MOD;		/* 0x192: TMRB1 Mode register */
extern unsigned char  TB1FFCR;		/* 0x193: TMRB1 Flip-flop control register */
/*---undefined---*/			/* 0x194: */
/*---undefined---*/			/* 0x195: */
/*---undefined---*/			/* 0x196: */
/*---undefined---*/			/* 0x197: */
/* extern unsigned int	TB1RG0;	*/	/* 0x198: TMRB1 Timer register0 */
extern unsigned char  TB1RG0L;	   	/* 0x198: TMRB1 Timer register0[low] */
extern unsigned char  TB1RG0H;	   	/* 0x199: TMRB1 Timer register0[high] */
/* extern unsigned int	TB1RG1;	*/	/* 0x19a: TMRB1 Timer register1 */
extern unsigned char  TB1RG1L;	   	/* 0x19a: TMRB1 Timer register1[low] */
extern unsigned char  TB1RG1H;	   	/* 0x19b: TMRB1 Timer register1[high] */
/* extern unsigned int	TB1CP0;	*/	/* 0x19c: TMRB1 Capture register0 */
extern unsigned char  TB1CP0L;	   	/* 0x19c: TMRB1 Capture register0[low] */
extern unsigned char  TB1CP0H;	   	/* 0x19d: TMRB1 Capture register0[high] */
/* extern unsigned int	TB1CP1;	*/	/* 0x19e: TMRB1 Capture register1 */
extern unsigned char  TB1CP1L;	   	/* 0x19e: TMRB1 Capture register1[low] */
extern unsigned char  TB1CP1H;	   	/* 0x19f: TMRB1 Capture register1[high] */

/***[0x200]************************************************************************/
extern unsigned char  SC0BUF;		/* 0x200: Serial transmission/Receiving buffer register(SIO0) */
extern unsigned char  SC0CR;		/* 0x201: Serial control register(SIO0) */
extern unsigned char  SC0MOD0;		/* 0x202: Serial mode control register0(SIO0) */
extern unsigned char  BR0CR;		/* 0x203: Baud rate generator control register(SIO0) */
extern unsigned char  BR0ADD;		/* 0x204: Baud rate generator control register(SIO0) */
extern unsigned char  SC0MOD1;		/* 0x205: Serial mode control register1(SIO0) */
/*---undefined---*/			/* 0x206: */
extern unsigned char  SIRCR;		/* 0x207: IrDA control register */
extern unsigned char  SC1BUF;		/* 0x208: Serial transmission/Receiving buffer register(SIO1) */
extern unsigned char  SC1CR;		/* 0x209: Serial control register(SIO1) */
extern unsigned char  SC1MOD0;		/* 0x20a: Serial mode control register0(SIO1) */
extern unsigned char  BR1CR;		/* 0x20b: Baud rate generator control register(SIO1) */
extern unsigned char  BR1ADD;		/* 0x20c: Baud rate generator control register(SIO1) */
extern unsigned char  SC1MOD1;		/* 0x20d: Serial mode control register1(SIO1) */
/*---undefined---*/			/* 0x20e: */
/*---undefined---*/			/* 0x20f: */

/***[0x240]************************************************************************/
extern unsigned char  SBI0CR1;		/* 0x240: Serial bus interface control register1 */
extern unsigned char  SBI0DBR;		/* 0x241: Serial bus interface data buffer register */
extern unsigned char  I2C0AR;		/* 0x242: I2C Bus address register */
extern unsigned char  SBI0CR2;		/* 0x243: Serial bus interface control register2 */
/*extern unsigned char  SBI0SR;	*/  /* 0x243: Serial bus interface status register */
extern unsigned char  SBI0BR0;		/* 0x244: Serial bus interface baud rate register0 */
extern unsigned char  SBI0BR1;		/* 0x245: Serial bus interface baud rate register1 */
/*---undefined---*/			/* 0x246: */
/*---undefined---*/			/* 0x247: */
/*---undefined---*/			/* 0x248: */
/*---undefined---*/			/* 0x249: */
/*---undefined---*/			/* 0x24a: */
/*---undefined---*/			/* 0x24b: */
/*---undefined---*/			/* 0x24c: */
/*---undefined---*/			/* 0x24d: */
/*---undefined---*/			/* 0x24e: */
/*---undefined---*/			/* 0x24f: */

/***[0x2A0]************************************************************************/
extern unsigned char  ADREG04L;		/* 0x2a0: A/D Conversion data lower register0/4 */
extern unsigned char  ADREG04H;		/* 0x2a1: A/D Conversion data upper register0/4 */
extern unsigned char  ADREG15L;		/* 0x2a2: A/D Conversion data lower register1/5 */
extern unsigned char  ADREG15H;		/* 0x2a3: A/D Conversion data upper register1/5 */
extern unsigned char  ADREG26L;		/* 0x2a4: A/D Conversion data lower register2/6 */
extern unsigned char  ADREG26H;		/* 0x2a5: A/D Conversion data upper register2/6 */
extern unsigned char  ADREG37L;		/* 0x2a6: A/D Conversion data lower register3/7 */
extern unsigned char  ADREG37H;		/* 0x2a7: A/D Conversion data upper register3/7 */
/*---undefined---*/			/* 0x2a8: */
/*---undefined---*/			/* 0x2a9: */
/*---undefined---*/			/* 0x2aa: */
/*---undefined---*/			/* 0x2ab: */
/*---undefined---*/			/* 0x2ac: */
/*---undefined---*/			/* 0x2ad: */
/*---undefined---*/			/* 0x2af: */

/***[0x2B0]************************************************************************/
extern unsigned char  ADMOD0;		/* 0x2b0: A/D Mode control register0 */
extern unsigned char  ADMOD1;		/* 0x2b1: A/D Mode control register1 */
/*---undefined---*/			/* 0x2b2: */
/*---undefined---*/			/* 0x2b3: */
/*---undefined---*/			/* 0x2b4: */
/*---undefined---*/			/* 0x2b5: */
/*---undefined---*/			/* 0x2b6: */
/*---undefined---*/			/* 0x2b7: */
/*---undefined---*/			/* 0x2b8: */
/*---undefined---*/			/* 0x2b9: */
/*---undefined---*/			/* 0x2ba: */
/*---undefined---*/			/* 0x2bb: */
/*---undefined---*/			/* 0x2bc: */
/*---undefined---*/			/* 0x2bd: */
/*---undefined---*/			/* 0x2bf: */

/***[0x300]************************************************************************/
extern unsigned char  WDMOD;		/* 0x300: Watchdog timer mode register */
extern unsigned char  WDCR;		/* 0x301: Watchdog timer control register */
/*---undefined---*/			/* 0x302: */
/*---undefined---*/			/* 0x303: */
/*---undefined---*/			/* 0x304: */
/*---undefined---*/			/* 0x305: */
/*---undefined---*/			/* 0x306: */
/*---undefined---*/			/* 0x307: */
/*---undefined---*/			/* 0x308: */
/*---undefined---*/			/* 0x309: */
/*---undefined---*/			/* 0x30a: */
/*---undefined---*/			/* 0x30b: */
/*---undefined---*/			/* 0x30c: */
/*---undefined---*/			/* 0x30d: */
/*---undefined---*/			/* 0x30e: */
/*---undefined---*/			/* 0x30f: */

/***[0x310]************************************************************************/
extern unsigned char  RTCCR;		/* 0x310: Timer for real time clock control register */
/*---undefined---*/			/* 0x311: */
/*---undefined---*/			/* 0x312: */
/*---undefined---*/			/* 0x313: */
/*---undefined---*/			/* 0x314: */
/*---undefined---*/			/* 0x315: */
/*---undefined---*/			/* 0x316: */
/*---undefined---*/			/* 0x317: */
/*---undefined---*/			/* 0x318: */
/*---undefined---*/			/* 0x319: */
/*---undefined---*/			/* 0x31a: */
/*---undefined---*/			/* 0x31b: */
/*---undefined---*/			/* 0x31c: */
/*---undefined---*/			/* 0x31d: */
/*---undefined---*/			/* 0x31e: */
/*---undefined---*/			/* 0x31f: */

/*-eof-*/
