/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: ctype.h,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2003/05/20 09:56:41 $	*/

#ifndef	__CTYPE_H
#define	__CTYPE_H

#ifndef __CTYPE_FNC
extern	const char	_ctype[];
#endif	/* __CTYPE_FNC */

#ifndef	__CDECL
#if	__STDC__
#define __CDECL
#else
#define __CDECL __cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#undef	__UC
#undef	__LC
#undef	__DIG
#undef	__SPC
#undef	__PNC
#undef	__CTL
#undef	__BLK
#undef	__HEX

#define	__UC	0x01	/* upper case		*/
#define	__LC	0x02	/* lower case		*/
#define	__DIG	0x04	/* digit number		*/
#define	__SPC	0x08	/* spacing character	*/
#define	__PNC	0x10	/* punctuation		*/
#define	__CTL	0x20	/* control character	*/
#define	__BLK	0x40	/* blank		*/
#define	__HEX	0x80	/* hexadecimal digit	*/

#undef	isalnum
#undef	isalpha
#undef	iscntrl
#undef	isdigit
#undef	isgraph
#undef	islower
#undef	isprint
#undef	ispunct
#undef	isspace
#undef	isupper
#undef	isxdigit
#undef	tolower
#undef	toupper

#undef	isascii
#undef	toascii
#undef	_tolower
#undef	_toupper

/* ANSI */
int __CDECL	isalnum(int c);
int __CDECL	isalpha(int c);
int __CDECL	iscntrl(int c);
int __CDECL	isdigit(int c);
int __CDECL	isgraph(int c);
int __CDECL	islower(int c);
int __CDECL	isprint(int c);
int __CDECL	ispunct(int c);
int __CDECL	isspace(int c);
int __CDECL	isupper(int c);
int __CDECL	isxdigit(int c);
int __CDECL	tolower(int c);
int __CDECL	toupper(int c);

/* Standard */
int __CDECL	isascii(int c);
int __CDECL	toascii(int c);
int __CDECL	_tolower(int c);
int __CDECL	_toupper(int c);

#ifndef __CTYPE_FNC

/* ANSI */
/* letter(A-Z or a-z) or digit(0-9) */
#define	isalnum(c)	(_ctype[(unsigned char)(c)] & (__UC|__LC|__DIG))
/* letter(A-Z or a-z) */
#define	isalpha(c)	(_ctype[(unsigned char)(c)] & (__UC|__LC))
/* 0x7f or 0x00-0x1f */
#define	iscntrl(c)	(_ctype[(unsigned char)(c)] & __CTL)
/* digit('0'-'9') */
#define	isdigit(c)	(_ctype[(unsigned char)(c)] & __DIG)
/* printing character except space character */
#define	isgraph(c)	(_ctype[(unsigned char)(c)] & (__PNC|__UC|__LC|__DIG))
/* lowercase letter(a-z) */
#define	islower(c)	(_ctype[(unsigned char)(c)] & __LC)
/* printing character(0x20-0x7e) */
#define	isprint(c)	(_ctype[(unsigned char)(c)] & (__PNC|__UC|__LC|__DIG|__BLK))
/* punctuaation character(iscntl or isspace) */
#define	ispunct(c)	(_ctype[(unsigned char)(c)] & __PNC)
/* space,tab,carriage return,newline,vertical tab,or formfeed */
#define	isspace(c)	(_ctype[(unsigned char)(c)] & __SPC)
/* uppercase letter(A-Z) */
#define	isupper(c)	(_ctype[(unsigned char)(c)] & __UC)
/* hexadecimal digit(0-9,A-F,a-f) */
#define	isxdigit(c)	(_ctype[(unsigned char)(c)] & __HEX)
/* convert to lowercase letter with check */
#define	tolower(c)	(isupper(c)?(c)+('a'-'A'):(c))
/* convert to uppercase letter with check */
#define	toupper(c)	(islower(c)?(c)+('A'-'a'):(c))

/* Standard */
/* in the range 0-127(0x00-0x7f) */
#define	isascii(c)	(!((c) & ~0x7f))
/* convert in the range 0 to 127 */
#define	toascii(c)	((c) & 0x7f)
/* convert to lowercase letter with no-check */
#define	_tolower(c)	((c) + ('a'-'A'))
/* convert to uppercase letter with no-check */
#define	_toupper(c)	((c) + ('A'-'a'))

#endif

#endif	/* __CTYPE_H */
