/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: float.h,v $	*/
/*	$Revision: 1.4 $	*/
/*	$Date: 2003/05/20 09:58:41 $	*/

#ifndef	__FLOAT_H
#define	__FLOAT_H

#ifdef UDE_CC	/* using UDE C compiler floating fixed number convert */

#define	PAI	3.14159265358979310000
#define PAI2	6.28318530717958620000
#define PAI5	1.57079632679489650000
#define LN2	0.69314718055994528000
#define LN102	0.30102999566398119000
#define LOGE	2.30258509299404590000

#else		/* floating fixed number bit pattern definition */

#ifndef __MATH_H

typedef union {
	unsigned char dat[4] ;
	float	val ;
} FLTBIT ;

typedef union {
	unsigned char dat[8] ;
	double	val ;
} DBLBIT ;

typedef union {
	unsigned char dat[10] ;
	long double	val ;
} LDBLBIT ;

#endif

extern	FLTBIT g_flttbl[] ;
extern	DBLBIT g_dbltbl[] ;
extern	LDBLBIT g_ldbltbl[] ;

#define	PAI	g_dbltbl[0].val
#define PAI2	g_dbltbl[1].val
#define PAI5	g_dbltbl[2].val
#define LN2	g_dbltbl[3].val
#define LN102	g_dbltbl[4].val
#define LOGE	g_dbltbl[5].val

#endif

#define	LOP	300
#define LMTPOW	0x41e0

#define	FLT_RADIX	2	/* expoent radix */

#define	FLT_ROUNDS	1

#ifdef UDE_CC	/* using UDE C compiler floating fixed number convert */


#define	DBL_DIG		15
#define	DBL_MANT_DIG	53
#define DBL_EPSILON	2.2204460492503131e-016
#define	DBL_MAX		1.79769313486231500e+308	/* for using Watcom C */
#define	DBL_MAX_10_EXP	308
#define	DBL_MAX_EXP	1024
/*	#define	DBL_MIN		2.2250738585072014e-308	*/
#define	DBL_MIN		2.22507385850720200e-308	/* for using Watcom C */
#define	DBL_MIN_10_EXP	(-307)
#define	DBL_MIN_EXP	(-1021)

#define	FLT_DIG		6
#define	FLT_EPSILON	1.192092896e-07F
#define	FLT_MANT_DIG	24
#define FLT_MAX 	3.402823466e+38F		/* for using Watcom C */
#define	FLT_MAX_10_EXP	38
#define	FLT_MAX_EXP	128
#define FLT_MIN 	1.175494351e-38F		/* for using Watcom C */
#define	FLT_MIN_10_EXP	(-37)
#define	FLT_MIN_EXP	(-125)

#define LDBL_DIG	18
#define LDBL_EPSILON	1.084202172485504434e-019L
#define LDBL_MANT_DIG	64
/*	 #define LDBL_MAX	1.189731495357231765e+4932L	*/
#define LDBL_MAX	DBL_MAX				/* for using Watcom C */
#define LDBL_MAX_10_EXP 4932
#define LDBL_MAX_EXP	16384
/*	 #define LDBL_MIN	3.362103143112093503e-4932L	*/
#define LDBL_MIN	3.362103143112093500e-4932L	/* for using Watcom C */
#define LDBL_MIN_10_EXP (-4931) 
#define LDBL_MIN_EXP	(-16381)

#else		/* floating fixed number bit pattern definition */

#define	DBL_DIG		15
#define	DBL_MANT_DIG	53
#define DBL_EPSILON	g_dbltbl[6].val
#define	DBL_MAX		g_dbltbl[7].val
#define	DBL_MAX_10_EXP	308
#define	DBL_MAX_EXP	1024
#define	DBL_MIN		g_dbltbl[8].val
#define	DBL_MIN_10_EXP	(-307)
#define	DBL_MIN_EXP	(-1021)

#define	FLT_DIG		6
#define	FLT_MANT_DIG	24
#define	FLT_EPSILON	g_flttbl[0].val
#define FLT_MAX 	g_flttbl[1].val
#define	FLT_MAX_10_EXP	38
#define	FLT_MAX_EXP	128
#define FLT_MIN 	g_flttbl[2].val
#define	FLT_MIN_10_EXP	(-37)
#define	FLT_MIN_EXP	(-125)

#define LDBL_DIG	18
#define LDBL_EPSILON	g_ldbltbl[0].val
#define LDBL_MANT_DIG	64
#define LDBL_MAX	g_ldbltbl[1].val
#define LDBL_MAX_10_EXP 4932
#define LDBL_MAX_EXP	16384
#define LDBL_MIN	g_ldbltbl[2].val
#define LDBL_MIN_10_EXP (-4931) 
#define LDBL_MIN_EXP	(-16381)

#endif
#endif	/* __FLOAT_H	*/
