/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: stdlib.h,v $	*/
/*	$Revision: 1.5 $	*/
/*	$Date: 2003/05/20 10:05:29 $	*/

#ifndef	__STDLIB_H
#define	__STDLIB_H

#ifndef	__CDECL
#if	__STDC__
#define	__CDECL
#else
#define	__CDECL	__cdecl
#endif	/* __STDC__ */
#endif	/* __CDECL */

#define	EXIT_FAILURE	1
#define	EXIT_SUCCESS	0
#define	MB_CUR_MAX	4
#define	RAND_MAX	0x7fffU

#ifndef	__SIZE_T
#define	__SIZE_T
typedef	unsigned int	size_t;
#endif

#ifndef	NULL
#define	NULL		((void *)0)
#endif

#ifndef	__DIV_T
#define	__DIV_T
typedef	struct div_t {
	int quot,rem;
} div_t;
typedef	struct ldiv_t {
	long quot,rem;
} ldiv_t;
#endif

#ifndef	__WCHAR_T
#define	__WCHAR_T
typedef	int		wchar_t;
#endif

/* ANSI */
void __CDECL	abort(void);
int __CDECL	atexit(void (*func)(void));
int __CDECL	abs(int j);
/* Not Yet */	double __CDECL	atof(const char *nptr);
int __CDECL	atoi(const char *nptr);
long __CDECL	atol(const char *nptr);
void * __CDECL	bsearch(const void *key, const void *base, size_t nmemb, size_t size, int (*compar)(const void *, const void *));
void * __CDECL	calloc(size_t nmemb, size_t size);
div_t __CDECL	div(int numer, int denom);
void __CDECL	exit(int status);
void __CDECL	free(void *ptr);
long __CDECL	labs(long int j);
ldiv_t __CDECL	ldiv(long int numer, long int denom);
void * __CDECL	malloc(size_t size);
void __CDECL	qsort(void *base, size_t nmemb, size_t size,int (*compar)(const void *, const void *));
int __CDECL	rand(void);
void * __CDECL	realloc(void *ptr, size_t size);
void __CDECL	srand(unsigned int seed);
/* Not Yet */	double __CDECL	strtod(const char *nptr, char **endptr);
long __CDECL	strtol(const char *nptr, char **endptr, int base);
unsigned long __CDECL	strtoul(const char *nptr, char **endptr, int base);

/* Not Support */	/*	char __CDECL	*getenv(const char *name);				*/
/* Not Support */	/*	int __CDECL	mblen(const char *s, size_t n);				*/
/* Not Support */	/*	int __CDECL	mbtowc(wchar_t *pwc, const char *s, size_t n);		*/
/* Not Support */	/*	size_t __CDECL	mbstowcs(wchar_t *pwcs, const char *s, size_t n);	*/
/* Not Support */	/*	int	system(const char *string);					*/
/* Not Support */	/*	size_t	wcstombs(char *s, const wchar_t *pwcs, size_t n);		*/
/* Not Support */	/*	int	wctomb(char *s, wchar_t wchar);					*/

/* Standard */
char * __CDECL	itoa(int val, char *s, int radix);
void * __CDECL	lfind(const void *key, const void *base, size_t *nmemb, size_t size, int (*compar)(const void *, const void *));
void * __CDECL	lsearch(const void *key, void *base, size_t *nmemb, size_t size, int (*compar)(const void *, const void *));
char * __CDECL	ltoa(long val, char *s, int radix);
char * __CDECL	ultoa(unsigned long val, char *s, int radix);

#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define __max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))
#define __min(a,b)	(((a) < (b)) ? (a) : (b))

#if defined (__900__) || defined (__870__) || defined (__870X__) || defined (__90__) || defined (__870C__)
#define __DI()		__asm("DI")
#define __EI()		__asm("EI")
#endif

#ifdef __900__
#define __EI900(x)	__asm("EI "#x)
#endif


#endif	/* __STDLIB_H */
