/* Copyright(C) 1994 TOSHIBA CORPORATION  All rights reserved */
/*	$RCSfile: __float.c,v $ */
/*	$Revision: 1.3 $ */
/*	$Date: 2002/06/14 08:04:05 $ */

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

typedef union {
	unsigned char	dat[4];
	float	val;
} FLTBIT;

typedef union {
	unsigned char	dat[8];
	double	val;
} DBLBIT;

typedef union {
	unsigned char	dat[10];
	long double	val;
} LDBLBIT;

#if defined(__TX19__) && defined(__BigEndian)
FLTBIT	g_flttbl[] = {
	{0x34,0x00,0x00,0x00},				/* FLT_EPSILON */
	{0x7f,0x7f,0xff,0xff},                          /* FLT_MAX */
	{0x00,0x80,0x00,0x00}                           /* FLT_MIN */
};
#else	/*  */
FLTBIT	g_flttbl[] = {
	{0x00,0x00,0x00,0x34},				/* FLT_EPSILON */
	{0xff,0xff,0x7f,0x7f},                          /* FLT_MAX */
	{0x00,0x00,0x80,0x00}                           /* FLT_MIN */
};
#endif  /* TX19-BigEndian */

#if defined(__TX19__)
#if defined(__LittleEndian__)
DBLBIT g_dbltbl[] = {
	{0xfb,0x21,0x09,0x40,0x18,0x2d,0x44,0x54},	/* PAI */
	{0xfb,0x21,0x19,0x40,0x18,0x2d,0x44,0x54},	/* PAI2 */
	{0xfb,0x21,0xf9,0x3f,0x18,0x2d,0x44,0x54},	/* PAI5 */
	{0x42,0x2e,0xe6,0x3f,0xef,0x39,0xfa,0xfe},	/* LN2 */
	{0x13,0x44,0xd3,0x3f,0xff,0x79,0x9f,0x50},	/* LN102 */
	{0xb1,0x6b,0x02,0x40,0x16,0x55,0xb5,0xbb},	/* LOGE */
	{0x00,0x00,0xb0,0x3c,0x00,0x00,0x00,0x00},	/* DBL_EPSILON */
	{0xff,0xff,0xef,0x7f,0xff,0xff,0xff,0xff},	/* DBL_MAX */
	{0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00}	/* DBL_MIN */
};
#else	/* __BigEndian__ */
DBLBIT g_dbltbl[] = {
	{0x40,0x09,0x21,0xfb,0x54,0x44,0x2d,0x18},	/* PAI */
	{0x40,0x19,0x21,0xfb,0x54,0x44,0x2d,0x18},	/* PAI2 */
	{0x3f,0xf9,0x21,0xfb,0x54,0x44,0x2d,0x18},	/* PAI5 */
	{0x3f,0xe6,0x2e,0x42,0xfe,0xfa,0x39,0xef},	/* LN2 */
	{0x3f,0xd3,0x44,0x13,0x50,0x9f,0x79,0xff},	/* LN102 */
	{0x40,0x02,0x6b,0xb1,0xbb,0xb5,0x55,0x16},	/* LOGE */
	{0x3c,0xb0,0x00,0x00,0x00,0x00,0x00,0x00},	/* DBL_EPSILON */
	{0x7f,0xef,0xff,0xff,0xff,0xff,0xff,0xff},	/* DBL_MAX */
	{0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00}	/* DBL_MIN */
};
#endif	/* endian */
#else	/* not TX19 */
DBLBIT g_dbltbl[] = {
	{0x18,0x2d,0x44,0x54,0xfb,0x21,0x09,0x40},	/* PAI */
	{0x18,0x2d,0x44,0x54,0xfb,0x21,0x19,0x40},	/* PAI2 */
	{0x18,0x2d,0x44,0x54,0xfb,0x21,0xf9,0x3f},	/* PAI5 */
	{0xef,0x39,0xfa,0xfe,0x42,0x2e,0xe6,0x3f},	/* LN2 */
	{0xff,0x79,0x9f,0x50,0x13,0x44,0xd3,0x3f},	/* LN102 */
	{0x16,0x55,0xb5,0xbb,0xb1,0x6b,0x02,0x40},	/* LOGE */
	{0x00,0x00,0x00,0x00,0x00,0x00,0xb0,0x3c},	/* DBL_EPSILON */
	{0xff,0xff,0xff,0xff,0xff,0xff,0xef,0x7f},	/* DBL_MAX */
	{0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00}	/* DBL_MIN */
};
#endif  /* TX19 */

#if defined(__TX19__)
#if defined(__LittleEndian__)
LDBLBIT	g_ldbltbl[] = {
	{0x00,0x00,0xb0,0x3c,0x00,0x00,0x00,0x00},	/* LDBL_EPSILON */
	{0xff,0xff,0xef,0x7f,0xff,0xff,0xff,0xff},	/* LDBL_MAX */
	{0x00,0x00,0x10,0x00,0x00,0x00,0x00,0x00}	/* LDBL_MIN */
};
#else	/* __BigEndian__ */
LDBLBIT	g_ldbltbl[] = {
	{0x3c,0xb0,0x00,0x00,0x00,0x00,0x00,0x00},	/* LDBL_EPSILON */
	{0x7f,0xef,0xff,0xff,0xff,0xff,0xff,0xff},	/* LDBL_MAX */
	{0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00}	/* LDBL_MIN */
};
#endif	/* endian */
#else	/* not TX19 */
LDBLBIT	g_ldbltbl[] = {
	{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xc0,0x3f},	/* LDBL_EPSILON */
	{0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0x7f},    /* LDBL_MAX */
	{0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0x7f,0x00,0x00}     /* LDBL_MIN */
};
#endif  /* TX19 */
