/*      Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved        */
/*	$RCSfile: _exp.c,v $	*/
/*	$Revision: 1.3 $	*/
/*	$Date: 2003/03/13 08:26:41 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <float.h>
#include <math.h>
#include <errno.h>

#define EDOM_MAX   709.7827128933840299
#define EDOM_MIN  -708.3964185322640219

#define N 26

double __CDECL exp(double x)
{
    int     i, k;
    double  w, z;

    if (x == 0.0)
        return 1.0;

    if (x > EDOM_MAX) {
        errno = ERANGE;
        return HUGE_VAL;
    }

    if (x < EDOM_MIN) {
        return 0.0;
    }

    k = (int)(x / LN2 + ((x >= 0) ? 0.5 : -0.5));
    x -= k * LN2;

    z = x * x;
    w = z / N;

    for (i = N-4; i >= 6; i-=4) {
        w = z / (w + i);
    }

    return ldexp((2 + w + x) / (2 + w - x), k);
}

