/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _qsort.c,v $	*/
/*	$Revision: 1.2 $	*/
/*	$Date: 2001/09/14 04:07:23 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <stdlib.h>
#include <string.h>

void __CDECL qsort(void *base, size_t nmemb, size_t size, int (*compar)(const void *, const void *))
{
	char *key ;
	char *first,*last,*max ;

	last = max = (char *)base + (nmemb - 1) * size ;
	first = base ;
	key = (char *)base + size * (nmemb >> 1) ;
	do {
		while ((*compar)(first, key) < 0) first += size ;
		while ((*compar)(key, last) < 0) last -= size ;
		if (first <= last) {
			if (first != last) {
				memswap(first, last, size) ;
				if (first == key) key = last ;
				else if (last == key) key = first ;
			}
			first += size ;
			last -= size ;
		}
	} while (first <= last) ;
	if (base < last)	qsort(base, (size_t)((last-(char*)base)/size+1), size, compar);
	if (first < max)	qsort(first, (size_t)((max-first)/size+1), size, compar);
}
