/*	Copyright(C) 1994 TOSHIBA Corporation All Rights Reseved	*/
/*	$RCSfile: _memswap.c,v $	*/
/*	$Revision: 1.3 $	*/
/*	$Date: 2001/09/14 04:14:23 $	*/

#if defined(__900__) && defined(PIC)
#pragma far_pic_on
#pragma far_pid_on
#endif 

#include <string.h>

#if defined(__900__) && !defined(PIC)
void * memswap(void *s1, void *s2, size_t n) {
	__ASM("		;; @(#)memswap.s	1.3 95/07/25");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; Not ANSI (TOSHIBA original)");
	__ASM("		;; void * memswap(void *s1, void *s2, size_t n)");
	__ASM("		;; RET	:		s1");
	__ASM("		;; s1	:		XSP+4");
	__ASM("		;; s2	:		XSP+8");
	__ASM("		;; n	:		XSP+12");
	__ASM("		;; ");
	__ASM("		ld		XHL,(XSP+4)		; s1");
	__ASM("		ld		BC,(XSP+12)		; n");
	__ASM("		cp		BC,0");
	__ASM("		ret		z			; don't swap");
	__ASM("		;;");
	__ASM("		ld		XDE,(XSP+8)		; s2");
	__ASM("		cp		XDE,XHL");
	__ASM("		ret		eq			; don't swap");
	__ASM("		;;");
	__ASM("		ld		IX,HL");
	__ASM("		neg		IX");
	__ASM("		and		IX,3			; 4m+0");
	__ASM("		j		z,__LongSwap");
	__ASM("		;;");
	__ASM("__ByteSwap:");
	__ASM("		ld		A,(XHL)");
	__ASM("		ld		W,(XDE)");
	__ASM("		ld		(XDE+),A");
	__ASM("		ld		(XHL+),W");
	__ASM("		sub		BC,1");
	__ASM("		j		z,__EndSwap");
	__ASM("		djnz	IX,__ByteSwap");
	__ASM("		;;");
	__ASM("__LongSwap:");
	__ASM("		ld		IX,BC");
	__ASM("		srl		2,BC");
	__ASM("		jr		z,__ByteSwap2");
	__ASM("__Loop:");
	__ASM("		ld		XWA,(XHL)");
	__ASM("		ld		XIY,(XDE)");
	__ASM("		ld		(XDE+),XWA");
	__ASM("		ld		(XHL+),XIY");
	__ASM("		djnz	BC,__Loop");
	__ASM("		;;");
	__ASM("__ByteSwap2:");
	__ASM("		and		IX,3");
	__ASM("		j		z,__EndSwap");
	__ASM("__Loop2:");
	__ASM("		ld		A,(XHL)");
	__ASM("		ld		W,(XDE)");
	__ASM("		ld		(XDE+),A");
	__ASM("		ld		(XHL+),W");
	__ASM("		djnz	IX,__Loop2");
	__ASM("__EndSwap:");
	__ASM("		ld		XHL,(XSP+4)");
	__ASM("		;; ret");
	return (void *)__XHL;
}
#elif defined(__90__)
void * memswap(void *s1, void *s2, size_t n) {
	__ASM("		;; @(#)memswap.s	1.2 95/12/25");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; Not ANSI (TOSHIBA original)");
	__ASM("		;; void * memswap(void *s1, void *s2, size_t n)");
	__ASM("		;; RET	:		s1");
	__ASM("		;; s1	:		SP+0x2");
	__ASM("		;; s2	:		SP+0x4");
	__ASM("		;; n	:		SP+0x6");
	__ASM("		;; ");
	__ASM("		ld		BC,(SP+0x6)		; n");
	__ASM("		ld		HL,BC");
	__ASM("		cp		HL,0");
	__ASM("		ld		HL,(SP+0x2)		; return s1");
	__ASM("		ret		z			; n==0 ?");
	__ASM("		;;");
	__ASM("		ld		IY,(SP+0x4)		; s2");
	__ASM("		cp		HL,IY");
	__ASM("		ret		eq			; s1==s2 ?");
	__ASM("		;;");
	__ASM("		ld		IX,HL			; s1");
	__ASM("		bit		0,C");
	__ASM("		jr		z,__WordSwap		; n==even ?");
	__ASM("		;;");
	__ASM("		ld		D,(IX)			;");
	__ASM("		ld		E,(IY)			;");
	__ASM("		ld		(IX),E			;");
	__ASM("		ld		(IY),D			; *p1<->*p2");
	__ASM("		inc		IX			; p1+1");
	__ASM("		inc		IY			; p2+1");
	__ASM("		djnz		BC,__WordSwap		; n-1,n!=0 ?");
	__ASM("		ret");
	__ASM("		;;");
	__ASM("__WordSwap:					; n==even");
	__ASM("		srl		B			;");
	__ASM("		rr		C			; n/2");
	__ASM("__WordSwapLoop:");
	__ASM("		ld		DE,(IX)			;");
	__ASM("		ex		(IY),DE			;");
	__ASM("		ld		(IX),DE			; *p1<->*p2,*(p1+1)<->*(p2+1)");
	__ASM("		inc		IX			; p1+1");
	__ASM("		inc		IX			; p1+1");
	__ASM("		inc		IY			; p2+1");
	__ASM("		inc		IY			; p2+1");
	__ASM("		djnz		BC,__WordSwapLoop	; n-1,n!=0 ?");
	__ASM("		;; ret");
	return (void *)__HL;
}
#elif (defined(__870X__) && defined(__LARGE__))
void * memswap(void *s1, void *s2, size_t n) {
	__ASM("		;; @(#)memswap.s	1.2 97/12/19");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; Not ANSI (TOSHIBA original)");
	__ASM("		;; void * memswap(void *s1, void *s2, size_t n)");
	__ASM("		;; RET	:		s1");
	__ASM("		;; s1	:		SP+0x4");
	__ASM("		;; s2	:		SP+0x7");
	__ASM("		;; n	:		SP+0xa");
	__ASM("		;;	");
	__ASM("		ld		IY,	(SP+0x4);	s1		");
	__ASM("		ld		IX,	(SP+0x7);	s2		");
	__ASM("		ld		WA,	(SP+0xa);	n		");
	__ASM("		test	A.0			;	odd?	");
	__ASM("		j		t,	__Div2	;			");
	__ASM("		;					;			");
	__ASM("__ByteSwap:");
	__ASM("		ld		E,	(IY)	;			");
	__ASM("		ld		D,	(IX)	;			");
	__ASM("		ld		(IX),E		;			");
	__ASM("		ld		(IY),D		;			");
	__ASM("		inc		IY			;			");
	__ASM("		inc		IX			;			");
	__ASM("		;					;			");
	__ASM("__Div2:");
	__ASM("		shrc	W			;			");
	__ASM("		rorc	A			;			");
	__ASM("		cmp		WA,	0x0		;			");
	__ASM("		j		t,	__End	;			");
	__ASM("__WordSwap:");
	__ASM("		ld		BC,	(IY)	;			");
	__ASM("		ld		DE,	(IX)	;			");
	__ASM("		ld		(IX),BC		;			");
	__ASM("		ld		(IY),DE		;			");
	__ASM("		inc		IY			;			");
	__ASM("		inc		IY			;			");
	__ASM("		inc		IX			;			");
	__ASM("		inc		IX			;			");
	__ASM("		dec		WA			;			");
	__ASM("		j		nz,	__WordSwap;			");
	__ASM("		;					;			");
	__ASM("__End:");
	__ASM("		ld		IY,	(SP+0x4);			");
	__ASM("		;					;ret		");
	return (void *)__IY;
}
#elif defined(__870X__)
void * memswap(void *s1, void *s2, size_t n) {
	__ASM("		;; @(#)memswap.s	1.3 98/10/07");
	__ASM("		;; (C)COPYRIGHT TOSHIBA CORP. 1995-");
	__ASM("		;; ");
	__ASM("		;; Not ANSI (TOSHIBA original)");
	__ASM("		;; void * memswap(void *s1, void *s2, size_t n)");
	__ASM("		;; RET	:		s1");
	__ASM("		;; s1	:		SP+0x4");
	__ASM("		;; s2	:		SP+0x6");
	__ASM("		;; n	:		SP+0x8");
	__ASM("		;					;	");
	__ASM("		push	HL			;	");
	__ASM("		ld		DE,	(SP+0x6);	s1		");
	__ASM("		ld		HL,	(SP+0x8);	s2		");
	__ASM("		ld		WA,	(SP+0xa);	n		");
	__ASM("		test	A.0			;	odd?	");
	__ASM("		j		t,	__Div2	;			");
	__ASM("		;					;			");
	__ASM("__ByteSwap:");
	__ASM("		ld		C,	(HL)	;			");
	__ASM("		ld		(HL),(DE)	;			");
	__ASM("		ld		(DE),C		;			");
	__ASM("		inc		DE			;			");
	__ASM("		inc		HL			;			");
	__ASM("		;					;			");
	__ASM("__Div2:");
	__ASM("		shrc	W			;			");
	__ASM("		rorc	A			;			");
	__ASM("		or		WA,	WA		;			");
	__ASM("		j		t,	__End	;			");
	__ASM("__WordSwap:");
	__ASM("		ld		BC,	(HL)	;			");
	__ASM("		ld		(HL),(DE)	;			");
	__ASM("		ld		(DE),C		;			");
	__ASM("		inc		DE			;			");
	__ASM("		inc		HL			;			");
	__ASM("		ld		(HL),(DE)	;			");
	__ASM("		ld		(DE),B		;			");
	__ASM("		inc		DE			;			");
	__ASM("		inc		HL			;			");
	__ASM("		dec		WA			;			");
	__ASM("		j		nz,	__WordSwap;			");
	__ASM("		;					;			");
	__ASM("__End:");
	__ASM("		ld		BC,	(SP+0x6);			");
	__ASM("		pop		HL			;			");
	__ASM("		;					;ret		");
	return (void *)__BC;
}
#else
void * __CDECL memswap(void *s1, void *s2, size_t n)
{
	unsigned char c;
	void *s = s1;
	unsigned char *p1 = s1;
	unsigned char *p2 = s2;

	for( ; n--; ++p1, ++p2) {
		c   = *p1;
		*p1 = *p2;
		*p2 = c;
	}
	return (s);
}
#endif

